/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_2_2_a_d.cpp

     Summary:           don't deallocate the memory for an array

     Test description:  the pointer to the array is a default member variable; the allocation and a pointer copy to a global pointer are in a member function; "double" is used for the datatype of the array

     Error line:        

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          array, deallocate, default member variable, member function, memory consumption, missing delete

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef SIZE
#define SIZE 100
#endif

// this is the declaration of a pointer to prevent a memory leak
double *ptrBackup;

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the pointer
        double *arrayA;

    public:
        void runA();
};

void TestClass :: runA() {
    // allocate memory
    cout << "allocate memory" << endl;
    arrayA=new double [SIZE];

    // initialize arrayA
    cout << "fill the array with random values" << endl;
    for ( int i=0; i < SIZE; i++) {
        arrayA[i]=rand();
    }

    // store the value of ptrA to prevent a memory leak
    ptrBackup=arrayA;

    // outsmart dead code elimination
    cout << "arrayA " << &arrayA << ", " << arrayA << ", " << arrayA[rand() % SIZE]  << endl;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
