/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_3_2_d_d.cpp

     Summary:           use "new" with "free"

     Test description:  the pointer is a global variable; the allocation with "new" is in the main function; the deallocation with "free" is in a static member function; "double" is used for the base datatype of the pointer

     Error line:        47

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          static member function, free, global variable, main function, new

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

// this is the declaration of the pointer
double *ptrA;

class TestClass {
    public:
        static void runA();
};

void TestClass :: runA() {
    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;

    // C style deallocation
    cout << "C style deallocation" << endl;
    free(ptrA);
}

int main() {
    // C++ style allocation
    cout << "C++ style allocation" << endl;
    ptrA=new double;

    // initialize *ptrA
    *ptrA=rand();

    TestClass::runA();
    return EXITCODE_OK;
}
