/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_3_3_i_f.cpp

     Summary:           use "calloc" with "delete []"

     Test description:  the pointer to the array is a public member variable of the class "TestClassData"; the allocation with "calloc" is in the constructor of the class "TestClassData"; the deallocation with "delete []" is in a member function of the class "TestClass"; "float" is used for the base datatype of the pointer to the array

     Error line:        69

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          class, member function, public member variable, calloc, constructor, delete

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef SIZE
#define SIZE 100
#endif

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
    public:
        TestClassData();
        // this is the declaration of the pointer
        float *arrayA;
};

TestClassData :: TestClassData() {
    // C-style allocation
    cout << "C-style allocation" << endl;
    arrayA=(float *) calloc(SIZE, sizeof(float));

    // initialize arrayA
    cout << "fill the array with random values" << endl;
    for ( int i=0; i < SIZE; i++) {
        arrayA[i]=rand();
    }
}

TestClassData classdataA;

class TestClass {
    public:
        void runA();
};

void TestClass :: runA() {
    // outsmart dead code elimination
    cout << "arrayA " << &classdataA.arrayA << ", " << classdataA.arrayA << ", " << classdataA.arrayA[rand() % SIZE]  << endl;

    // C++ style deallocation
    cout << "C++ style deallocation" << endl;
    delete [] classdataA.arrayA;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
