/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_3_4_a_d.cpp

     Summary:           use "new []" and "delete []" with "realloc"

     Test description:  the pointer is a default member variable; the allocation with "new []" is in the constructor; the reallocation with "realloc" is in a member function; the deallocation with "delete []" is in the destructor; "double" is used for the base datatype of the pointer

     Error line:        75

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          constructor, member function, default member variable, delete, destructor, new, realloc

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef SIZE
#define SIZE 100
#endif

#ifndef SIZE2
#define SIZE2 123
#endif

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the pointer
        double *arrayA;

    public:
        TestClass();
        ~TestClass();
        void runA();
};

TestClass :: TestClass() {
    // C++ style allocation
    cout << "C++ style allocation" << endl;
    arrayA=new double [SIZE];

    // initialize arrayA
    cout << "fill the array with random values" << endl;
    for ( int i=0; i < SIZE; i++) {
        arrayA[i]=rand();
    }
}

TestClass :: ~TestClass() {
    // C++ style deallocation
    cout << "C++ style deallocation" << endl;
    delete [] arrayA;
}

void TestClass :: runA() {
    // outsmart dead code elimination
    cout << "arrayA " << &arrayA << ", " << arrayA << ", " << arrayA[rand() % SIZE]  << endl;

    // C style reallocation
    cout << "C style reallocation" << endl;
    arrayA=(double *) realloc (arrayA, SIZE2 *sizeof(double));

    // outsmart dead code elimination
    cout << "arrayA " << &arrayA << ", " << arrayA << ", " << arrayA[rand() % SIZE2]  << endl;

}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
