/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_4_1_b_ld.cpp

     Summary:           use "delete" twice with the same pointer

     Test description:  the pointer is a default member variable; the allocation is in the constructor; one delete is in the destructor; the additional delete is in a inline member function; "long double" is used for the base datatype of the pointer

     Error line:        63

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          constructor, inline member function, deallocate twice, default member variable, delete, destructor, same pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
    private:
        // this is the declaration of the pointer
        long double *ptrA;

    public:
        TestClass();
        ~TestClass();
        void runA() {
            // memory deallocation
            cout << "deallocation" << endl;
            delete ptrA;
        }
};

TestClass :: TestClass() {
    // memory allocation
    cout << "allocation" << endl;
    ptrA=new long double;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

TestClass :: ~TestClass() {
    // memory deallocation
    cout << "deallocation" << endl;
    delete ptrA;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
