/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_4_1_d_d.cpp

     Summary:           use "delete" twice with the same pointer

     Test description:  the pointer is a global variable; the allocation is in the main function; one delete is in the main function; the additional delete is in a static member function; "double" is used for the base datatype of the pointer

     Error line:        62

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          static member function, deallocate twice, delete, global variable, main function, same pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

// this is the declaration of the pointer
double *ptrA;

class TestClass {
    public:
        static void runA();
};

void TestClass :: runA() {
    // memory deallocation
    cout << "deallocation" << endl;
    delete ptrA;
}

int main() {
    // memory allocation
    cout << "allocation" << endl;
    ptrA=new double;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;

    TestClass::runA();

    // memory deallocation
    cout << "deallocation" << endl;
    delete ptrA;
    return EXITCODE_OK;
}
