/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_4_1_i_f.cpp

     Summary:           use "delete" twice with the same pointer

     Test description:  the pointer is a public member variable of the class "TestClassData"; the allocation is in the constructor of the class "TestClassData"; one delete is in the destructor of the class "TestClassData"; the additional delete is in a member function of the class "TestClass"; "float" is used for the base datatype of the pointer

     Error line:        56

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          class, constructor, member function, public member variable, deallocate twice, delete, destructor, same pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
    public:
        TestClassData();
        ~TestClassData();
        // this is the declaration of the pointer
        float *ptrA;
};

TestClassData :: TestClassData() {
    // memory allocation
    cout << "allocation" << endl;
    ptrA=new float;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

TestClassData :: ~TestClassData() {
    // memory deallocation
    cout << "deallocation" << endl;
    delete ptrA;
}

TestClassData classdataA;

class TestClass {
    public:
        void runA();
};

void TestClass :: runA() {
    // memory deallocation
    cout << "deallocation" << endl;
    delete classdataA.ptrA;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
