/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_4_1_o_f.cpp

     Summary:           use "delete" twice with the same pointer

     Test description:  the pointer is a "static" member variable; the allocation is in the constructor; the delete is in the destructor; 2 objects of this class are create; "double" is used for the base datatype of the pointer.

     Error line:        71

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          deallocate twice, delete, same pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

// this is the declaration of a pointer to prevent a memory leak
float *ptrBackupA=0;
float *ptrBackupB=0;

class TestClass
{
        // this is the declaration of the pointer
        static float *ptrA;

    public:
        TestClass();
        ~TestClass();
};

// this is the definition of the pointer
float *TestClass::ptrA;

TestClass :: TestClass()
{
    // memory allocation
    cout << "allocation" << endl;
    ptrA=new float;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

TestClass :: ~TestClass()
{
    // store the value of ptrA to prevent a memory leak
    ptrBackupB=ptrBackupA;
    ptrBackupA=ptrA;

    // memory deallocation
    cout << "deallocation" << endl;
    delete ptrA;
}

int main()
{
    TestClass* testclassA = new TestClass;
    TestClass* testclassB = new TestClass;
    delete testclassB;
    delete testclassA;
    return EXITCODE_OK;
}
