/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_G_4_2_a_d.cpp

     Summary:           use "delete []" twice on the same pointer to an array

     Test description:  the pointer to the array is a default member variable; the allocation is in the constructor; one delete is in the destructor; the second delete is in a member function; "double" is used for the datatype of the array

     Error line:        65

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          constructor, member function, array, deallocate twice, default member variable, delete, destructor, same pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef SIZE
#define SIZE 100
#endif

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the pointer
        double *arrayA;

    public:
        TestClass();
        ~TestClass();
        void runA();
};

TestClass :: TestClass() {
    // memory allocation
    cout << "allocation" << endl;
    arrayA=new double [SIZE];

    // initialize arrayA
    cout << "fill the array with random values" << endl;
    for ( int i=0; i < SIZE; i++) {
        arrayA[i]=rand();
    }

    // outsmart dead code elimination
    cout << "arrayA " << &arrayA << ", " << arrayA << ", " << arrayA[rand() % SIZE]  << endl;
}

TestClass :: ~TestClass() {
    // memory deallocation
    cout << "deallocation" << endl;
    delete [] arrayA;
}

void TestClass :: runA() {
    // memory deallocation
    cout << "deallocation" << endl;
    delete [] arrayA;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
