/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_2_1_b.c
*
*    Test description:	Reallocate memory that has never been allocated. 
*                       Call realloc() in a function using a pointer passed
*                       by address from main function; the pointer has an address
*                       of stack memory variable.
*                       The file must be compiled with file c_G_2_1_b.c
*
*    Error line:        38
*
*    Keywords:		memory reallocation error
*                       realloc stack memory
*                       function
*			realloc()
*                       int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

void func(int **ptrA)
{
/* reallocate memory that has never been allocated */

   *ptrA = (int *)realloc(*ptrA, N*sizeof(int));
   if(!(*ptrA))
    { 
      exit(EXITCODE_ERROR);
    }   
   free(*ptrA);
}
