/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_2_2_a.c
*
*    Test description:	Reallocate memory  memory that has been freed. 
*                       Allocate memory, deallocate it, and then reallocate;
*                       use a local pointer in a function.
*                       The file must be compiled with file c_G_2_2_a.c
*
*    Error line:        53
*
*    Keywords:		memory reallocation error
*                       reallocate freed memory
*                       function
*                       freed pointer
*			realloc()
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

void func()
{
   int *ptrA, sum = 0;
   int i;

   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrA[i] = N - i;
   for(i=0;i<N;i++) sum = sum + ptrA[i];
    
   free(ptrA);

   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */

   ptrA = (int *)realloc(ptrA, K*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   free(ptrA);
}


