/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_1_1_e.c
*
*    Test description:	Read one element before the lower bound of an array
*			of structures declared and used in a function. 
*			Use array indexing.
*			The file must be compiled with file c_E_1_1_e.c
*
*    Error line:        44
*
*    Keywords:		out-of-bounds
*			array indexing
*			array of structures
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 28, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int c;
   int i;
   struct aab {
       char * nm;
       int b;
   } ss[N];

   for(i=0; i<N; i++)
       ss[i].b = i;
   i = i - N - 1;
   c = ss[i].b;  /* read one element before the lower bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 

   return ret2;
}

