/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_2_1_a.c
*
*    Test description:	Read one element before the lower bound of 
*			a single-dimensional stack array in a block
*			using an array of indexes.
*
*    Error line:        53
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			stack array
*			main function
*			block
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 28, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   int a; 
   int i, index[N];

   for(i=0; i<N; i++)
       index[i] = i-1;
   {
     int arrayA[N];
     for(i=0; i<N; i++)
         arrayA[i] = i;
     a = arrayA[index[0]];  /* read one element before the lower bound */
   }

   ret();
   if(ret2==0) {                  /* the value of ret2 = 1 */
     printf("Variable a=%d", a);
   } 
   
   return EXITCODE_OK; 
}
