/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_4_3_d.c
*
*    Test description:	Read one element past the upper bound of 
*			a dynamically allocated array that is a member 
*			of a structure declared in a function. 
*			Use array indexing.
*			The file must be compiled with file c_E_4_3_d.c
*
*    Error line:        55
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			function
*			structure
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 29, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(void)
{
   int b;
   int i;
   struct aab {
       char * nm;
       int *ptr;
   } ss;

   ss.ptr = (int *)malloc(N*sizeof(int));
   if(!ss.ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
       ss.ptr[i] = i;
   b = ss.ptr[i];  /* read one element past the upper bound */

   free(ss.ptr);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable b=%d", b);
   } 

   return ret2;
}

