/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_4_6_f.c
*
*    Test description:	Write K elements before the lower bound of 
*			a dynamically allocated array using a subscript.
*			The array is declared using a global pointer;
*			allocated and used in a function.
*			The file must be compiled with file c_E_4_6_f.c
*
*    Error line:        52
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			global pointer
*			function
*			write
*                       int
*
*    Last modified:	July 29, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int *ptr;

int func(void)
{
   int b = 0, sum = 0;
   int i;

   ptr = (int *)malloc(N*sizeof(int));
   if(!ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
        ptr[i] = i;
   i = i - N - K;
   ptr[i] = b;  /* write K elements before the lower bound */
   for(i=0; i<N; i++)
       sum = sum + ptr[i];

   free(ptr);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

