/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_5_1_c.c
*
*    Test description:	Read one element before the lower bound of 
*			a dynamically allocated multidimensional array 
*			using a subscript.
*			The array is declared in main function and 
*			passed to a function as an argument.
*			The file must be compiled with file c_E_5_1_c.c
*
*    Error line:        39
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			multidimensional array
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 30, 2005
*/

#include "TEST_PARAM.H"

int func(int **ptr, int i)
{
   int c;

   c = ptr[0][i];  /* read one element before the lower bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 

   return ret2;
}

