/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_B_1_1_a_d.cpp

     Summary:           divide by zero

     Test description:  varO is a default member variable; the division is in a member function; "double" is used for varD and varV

     Error line:        48

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          overloaded operator, default member variable, divide by zero, member function

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>

#ifndef DIV0
#define DIV0 23
#endif

// this is the declaration of the class that has an overloaded "operator /"
class OperatorClass {
        double varV;

    public:
        // the 2 argument "operator << " needs access to varV
        friend ostream & operator << (ostream& os, const OperatorClass& value);

        // the "operator =" stores a new value in varV
        void operator=(const double& value) {
            varV=value;
        }

        // this is the "operator /" where the divide by zero error should occur
        double operator / (const double& varR) {
            cout << varV << " / " << varR << endl;
            return varV / varR;
        }
};

// the 2 argument "operator << " prints the value in varV
ostream & operator << (ostream& os, const OperatorClass& value) {
    os << value.varV;
    return os;
}

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the object that has an overloaded "operator /"
        OperatorClass varO;

    public:
        void runA();
};

void TestClass :: runA() {
    // varO is initialized with 23
    varO=23;

    // varD is the divider that is decreased
    double varD;
    varD=DIV0;

    // this while loop decreases varD until it is 0 and uses the overloaded "operator /"
    do {
        varD--;
        varO=varO / varD;
    } while ( varD != 0 );

    // output the last result
    cout << varO << endl;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
