/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_I_1_1_j_d.cpp

     Summary:           use "new" twice with the same pointer

     Test description:  the pointer is a default member variable; one allocation is in the constructor; the second allocation is in a member function of a friend class; one deallocation is in the destructor; "double" is used for the base datatype of the pointer

     Error line:        71

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          class, constructor, default member variable, friend, member function, allocate twice, destructor, new, same pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
        friend class TestClass;
        // this is the declaration of the pointer
        double *ptrA;

    public:
        TestClassData();
        ~TestClassData();
};

TestClassData :: TestClassData() {
    // memory allocation
    cout << "allocation by using new" << endl;
    ptrA=new double;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

TestClassData :: ~TestClassData() {
    // memory deallocation
    cout << "deallocation by using delete" << endl;
    delete ptrA;
}

class TestClass {
        TestClassData classdataA;

    public:
        void runA();
};

void TestClass :: runA() {
    // memory allocation
    cout << "allocation by using new" << endl;
    classdataA.ptrA=new double;

    // initialize
    *classdataA.ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &classdataA.ptrA << ", " << classdataA.ptrA << ", " << *classdataA.ptrA << endl;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
