/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_I_2_1_a_d.cpp

     Summary:           losing a pointer to a variable by leaving a function

     Test description:  the pointer declaration and the memory allocation are in a member function; the member function is called in the main function; "double" is used for the base datatype of the pointer.

     Error line:        53

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          allocate, function, local variable, member function, losing pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass
{
    public:
        void runA();
};

void TestClass :: runA()
{
    // this is the declaration of the pointer
    double *ptrA;

    // memory allocation
    cout << "allocation by using new" << endl;
    ptrA=new double;

    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

int main()
{
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
