/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_I_2_2_a_d.cpp

     Summary:           losing a pointer which is a function formal argument when returning from the function

     Test description:  the pointer is declared as a formal argument of a function; the function is called from the main function with the operator new as the argument; "double" is used for the base datatype of the pointer.

     Error line:        54

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          allocate, argument passed, formal argument, function, member function, losing pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass
{
    public:
        void runA(double *ptrA);
};

void TestClass :: runA(double *ptrA)
{
    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

int main()
{
    TestClass testclassA;

    // memory allocation and member function call
    cout << "call run (new ...)" << endl;
    testclassA.runA(new double);

    return EXITCODE_OK;
}
