/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_I_2_3_b_d.cpp

     Summary:           losing a pointer to a variable by deleting an object that contains the pointer

     Test description:  the pointer to the variable is a "public" member variable; the allocation of the variable is in the constructor; an object of this class is declared in a function that is called from the main function; "double" is used for the base datatype of the pointer.

     Error line:        63

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          allocate, class, function, member variable, object, losing pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass
{
    public:
        // this is the declaration of the pointer
        double *ptrA;

        TestClass();
        void runA();
};

TestClass :: TestClass()
{
    // memory allocation
    cout << "allocation ptrA" << endl;
    ptrA=new double;
}

void TestClass :: runA()
{
    // initialize
    *ptrA=rand();

    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << ", " << *ptrA << endl;
}

void fctA()
{
    TestClass testclassA;
    testclassA.runA();
}

int main()
{
    fctA();
    return EXITCODE_OK;
}
