/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_I_3_3_a_d.cpp

     Summary:           overwrite the pointer with zero by using a reference of it

     Test description:  the pointer is a default member variable; the allocation is in the constructor; the reference and the altering are in a member function; the deallocation is in the destructor; "double" is used for the base datatype of the pointer

     Error line:        70

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          constructor, member function, overwrite, pointer, reference, allocate, default member variable, destructor

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the pointer
        double *ptrA;

    public:
        TestClass();
        ~TestClass();
        void runA();
};

TestClass :: TestClass() {
    // allocate memory
    cout << "allocate memory" << endl;
    ptrA=new double;

    // initialize ptrA
    *ptrA=rand();
}

TestClass :: ~TestClass() {
    // outsmart dead code elimination
    cout << "ptrA " << &ptrA << ", " << ptrA << endl;

    // deallocate memory
    cout << "deallocate memory" << endl;
    delete ptrA;
}

void TestClass :: runA() {
    // a reference to the pointer
    double *&refA=ptrA;

    // outsmart dead code elimination
    cout << "refA " << &refA << ", " << refA << ", " << *refA << endl;

    // modify the pointer by setting the refA=0
    cout << "modify pointer" << endl;
    refA=0;
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
