/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .
*    Test name:		c_I_1_c.c
*
*    Test description:	Allocate memory twice using the same pointer 
*                       without deallocating it first 
*                       and without associating another pointer   
*                       with the first block of memory. 
*                       Pass a pointer by address to two different functions 
*                       where it is used to allocate memory.
*
*    Support files:     c_I_1_c_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory leak
*                       double allocation
*                       unreferenced memory
*			function
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_CONST.H"
#include <stdio.h> 
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int sum = 0;

void func_2(int **);

void func_1(int **ptr)
{
   int i;

   *ptr = (int *)malloc(N*sizeof(int));
   if(!*ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) (*ptr)[i] = N - i;
   for(i=0;i<N;i++) sum = sum + (*ptr)[i];
}

int main(void)
{
   int *ptrA;
   
   func_1(&ptrA);
   func_2(&ptrA);
   free(/*DEALLOC*/ptrA);
     
   return EXITCODE_OK;
}
