/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_1_d.c
*
*    Test description:	Allocate memory twice using the same pointer 
*                       without deallocating it first 
*                       and without associating another pointer   
*                       with the first block of memory. 
*                       Pass a pointer by address to a function 
*                       where use it to allocate memory; do recursive call.
*                       The file must be compiled with file c_I_1_d.c
*
*    Error line:        42
 *
*    Keywords:		memory leak
*                       double allocation
*                       unreferenced memory
*			recursive function
*			int
*
*    Last modified:	June 30, 2005
*/


#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int count;

void func(int **ptr)
{
   int sum = 0;
   int i;
            
   *ptr = (int *)malloc(N*sizeof(int));
   if(!*ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) (*ptr)[i] = count + i;
   for(i=0;i<N;i++) sum = sum + (*ptr)[i];

   count++;
    
   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */
 
   if(count < 2)
      func(ptr);
   else
      free(/*DEALLOC*/*ptr);
}
