/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_4_b.c
*
*    Test description:	Allocate a multidimensional array,  
*                       deallocate only one dimension.
*                       Use a pointer in a function.
*                       The file must be compiled with file c_I_4_b.c
*
*    Error line:        63
*
*    Keywords:		memory leak
*                       global pointer
*			function
*			int
*
*    Last modified:	June 30, 2005
*/


#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int **ptrA;

void func(void)
{
   int sum = 0;
   int i, j;

   ptrA = (int **)malloc(N*sizeof(int *));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
    {
      ptrA[i] = (int *)malloc(N*sizeof(int));
      if(!ptrA[i])
       { 
         printf("Out of memory.\n");
         exit(EXITCODE_ERROR);
       }   
     }
   for(i=0; i<N; i++)
       for(j=0; j<N; j++)
           ptrA[i][j] = i+j;

   for(i=0;i<N;i++) 
       for(j=0; j<N; j++)
           sum = sum + ptrA[i][j];
   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */

   free(ptrA);
}
