/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_5_b.c
*
*    Test description:	Allocate memory in a function, do not deallocate it upon exit 
*                       from the function without associating another pointer with it.
*
*    Support files:     c_I_5_b_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory leak
*                       unreferenced memory
*			function
*			int
*
*    Last modified:	June 30, 2005
*/

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

void func(void);

int main(void)
{
   func();
   return EXITCODE_OK;
}
