/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_J_1_2_a_d.cpp

     Summary:           write a "public" member variable by using an object pointer with the value null

     Test description:  the pointer to the object is a global variable; the pointer is set to null in the main function; the write by using the null pointer is in the main function; "double" is used for the datatype of the "public" member variable.

     Error line:        70

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          null, object, pointer, write, address

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass
{

    public:
        // this is the declaration of the variable
        double varA;

        TestClass();
        ~TestClass();
};

TestClass :: TestClass()
{
    varA=0;
}

TestClass :: ~TestClass()
{
    cout << "varA=" << varA << endl;
}

TestClass *testclassA;

int main()
{
    // set the pointer testclassA to null
    testclassA=0;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10)
    {
        cout << "this should never be called" << endl;
        testclassA=new TestClass;
    }

    // invalid acces by using a null pointer
    cout << "access by using a null pointer" << endl;
    testclassA->varA=rand();

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10)
    {
        cout << "this should never be called" << endl;
        cout << testclassA->varA << endl;
        delete testclassA;
    }

    return EXITCODE_OK;
}
