/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_J_1_4_a_d.cpp

     Summary:           call a member function by using a function pointer that has a null value

     Test description:  the pointer of the member function is a global variable; the pointer is set to null in the main function; the call of a member function by using the null pointer is in the main function.

     Error line:        64

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          call, function, null, pointer, address

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassClass
{

    public:
        void runA();
};

void TestClassClass :: runA()
{
    cout << "this is a test " << rand() << endl;
}

void (TestClassClass::*testclassAPtr)();

int main()
{
    // this is the object of the class TestClassClass
    TestClassClass testclassA;

    // set the pointer testclassAPtr to null
    testclassAPtr= 0;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10)
    {
        cout << "this should never be called" << endl;
        testclassAPtr=&TestClassClass::runA;
    }

    // invalid acces by using a null pointer
    cout << "access by using a null pointer" << endl;
    (testclassA.*testclassAPtr)();

    return EXITCODE_OK;
}
