/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_1_6_c.c
*
*    Test description:	Write K elements before the lower bound of 
*			a single-dimensional stack array declared in main function
*			and passed by another pointer to a function where it is used.
*			The file must be compiled with file c_F_1_6_c.c
*
*    Error line:        40
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			stack array
*			function
*			write
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

int func(int *ptr)
{
   int c = 0, sum = 0;
   int i;
    
   for(i=0; i<N; i++)
       sum = sum + ptr[i];
   ptr-=K;
   *ptr = c;  /* write K elements before the lower bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}
