/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_2_5_a.c
*
*    Test description:	Read K elements before the lower bound of 
*			a dynamically allocated array in a block.
*			Use another pointer initially set to point to the array
*                       and then moved outside the bounds.
*
*    Error line:        63
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			dynamically allocated array
*			main function
*			block
*			read
*                       int
*
*    Last modified:	July 31, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
   int a, *ptr; 
   int i;

   {
     int *arrayA;
     
     arrayA = (int *)malloc(N*sizeof(int));
     if(!arrayA)
      { 
        printf("Out of memory.\n");
        exit(EXITCODE_ERROR);
      }   
     for(i=0; i<N; i++)
         arrayA[i] = i;
     ptr = arrayA;
     ptr-=K;
     a = *ptr;  /* read K elements before the lower bound */
     
     free(arrayA);
    }

   ret();
   if(ret2==0) {                  /* the value of ret2 = 1 */
     printf("Variable a=%d", a);
   } 
   
   return EXITCODE_OK; 
}
