/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_2_5_d.c
*
*    Test description:	Read K elements before the lower bound of 
*			a dynamically allocated array declared and used 
*			in a function as a member of a structure. 
*			Use another pointer initially set to point to the array
*                       and then moved outside the bounds.
*			The file must be compiled with file c_F_2_5_d.c
*
*    Error line:        58
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			dynamically allocated array
*			function
*			structure
*			read
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(void)
{
   int c, *ptr; 
   struct aab {
       char * nm;
       int *arrayA;
   } ss;
   int i;

   ss.arrayA = (int *)malloc(N*sizeof(int));
   if(!ss.arrayA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
       ss.arrayA[i] = i;
   ptr = ss.arrayA;
   ptr-=K;
   c = *ptr;  /* read K elements before the lower bound */

   free(ss.arrayA);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 

   return ret2;
}
