/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_J_4_a.c
*
*    Test description:	Access unallocated memory.
*                       Allocate 1 byte of memory, then write an integer variable 
*                       to it.
*
*    Error line:        50
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		access unallocated memory
*                       write
*                       main
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
   int *ptrA, varA=0;
   int i;

   ptrA = (int *)malloc(1);
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   

   *ptrA = varA;   /* write to unallocated memory */

   ret();
   if(ret1!=1) printf("Variable ptrA=%d", *ptrA);

   return EXITCODE_OK;
}


