/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_D_1_1_b.c
*
*    Test description:	Copy n characters from str2 to str1 
*                       using memcpy(str1,str2,n) when n is greater 
*                       than size of str1.
*                       The strings are declared in stack memory.
*
*    Error line:        45
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		string
*                       stack memory
*                       write overflow
*                       memcpy
*
*    Last modified:	June 17, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
  char str1[]="short string";
  char str2[]="longer string";
  int n=sizeof(str2);

  memcpy(str1,str2,n);

  ret();
  if(ret1!=1)               /* ret1 = 1 */
     printf ("%s \n",str1); /* use the value to prevent code elimination */

  return EXITCODE_OK; 
}
