#!/bin/perl

# This is to translate the dat file to correct overly
# specific messages arising in the @error_name field.
# This was causing too may false fails, so we change 
# from straight test, which was what was used, to perl
# regular expressions, with the exception of the | symbol
# which acts as a logical or, rather than the normal perl || .

#open(FH1,"translate_dat.data") || die "Can't open translate_dat.data\n";
#while(<FH1>) {
# Read in expression from data file
#}

# Hard code translation in this file.

#'readafterwriteinvalid','read/&&/afterwrite|endoffile|end-of-file',
#'fileaccessconflict','direct/&&/sequential|direct/&&/record|sequential/&&/recordnumber|access/&&/conflict',
%TRANSLATION=(
'i\\\/oformconflictswithopenform','unformatted.*formatted|formatted.*unformatted|format.*formatted',
'i\\\/oformconflictwithopenform','unformatted.*formatted|formatted.*unformatted|format.*formatted',
'readafterwriteinvalid','read/&&/afterwrite|endoffile|end\-of\-file|endofthefile',
'allocationconflict','allocation/&&/conflict|delete/&&/malloc|new/&&/free|new/&&/realloc',
'alreadyallocated','allocated',
'arraytoolargeforavailablememory','available/&&/memory|alloc/&&/fail',
'badfiledescriptor','uninitiali|unassigned|dangling|undefined|file/&&/descriptor',
'conformanceerror','conformanceerror|notconform|expect/&&/instead',
'danglingpointer','dangling/&&/pointer',
'deallocateapointer','deallocat/&&/pointer|allocate/&&/deallocat',
'dimensionconflict','scalar/&&/array|rankmismatch|dimensionconflict',
'disassociatedpointer','disassociated/&&/pointer/&&/deallocat|notallocated/&&/deallocat|notcreated/&&/deallocat',
'dividebyzero','divide/&&/zero|division/&&/zero|divizion/&&/zero',
'dividebyzerocondition','divide/&&/zero|division/&&/zero|divizion/&&/zero',
'fileaccessconflict','direct/&&/sequential|direct/&&/record|sequential/&&/record|direct*non\-direct|non\-direct.*direct|direct.*nondirect|nondirect.*direct',
'filedoesnotexist','file/&&/notexist|nosuch/&&/file',
'freedanglingpointer','dangling/&&/pointer|duplicate/&&/free|freed',
'freeincorrectpointer','free/&&/incorrect/&&/pointer|free/&&/local|free/&&/global|free/&&/body|free/&&/unallocatedblock|free/&&/notallocated|freed',
'freeinganinvalidaddress','free/&&/incorrect/&&/pointer|free/&&/wild/&&/pointer|free/&&/local|free/&&/global|free/&&/body|free/&&/unallocatedblock|free/&&/notallocated|freed',
'freeuninitializedpointer','free/&&/uninitiali/&&/pointer|free/&&/unassigned/&&/pointer|free/&&/notinitiali/&&/pointer|free/&&/undefined/&&/pointer',
'incorrectnumberofarguments','numberofarguments|toomany|notenough|expect/&&/argument',
'invalidcharacterinnumericfield','invalid|incompatible|notmatch|data/&&/conversion|input/&&/conversion',
'invalidstreamaccess','invalid/&&/stream',
'memoryblocknotfreed','memory/&&/notfreed|memory/&&/outstanding/&&/allocated',
'memoryleak','memory/&&/leak',
'memoryoverflow','memory/&&/overflow|past/&&/stack|past/&&/heap',
'memoryoverlap','memory/&&/overlap',
'notassociatedwithanytarget','notassociated|notassigned|notallocated|undefined|unallocated|disassociated',
'nullpointer','nullpointer|null\-pointer',
'nullpointeraccess','nullpointer|null\-pointer',
'numberofarguments','numberofarguments|toomany|notenough',
'outofbounds','bound/&&/smallerthan|bound/&&/lessthan|bound/&&/greaterthan|bound/&&/exceed|outof/&&/bound|range/&&/exceed|outof/&&/range|subscript/&&/range/&&/violation|before/&&/heap/&&/block|before/&&/stack/&&/block|writ/&&/overflow|read/&&/overflow|indexerror|indexingerror|read/&&/uninitiali/&&/memory',
'outofrange','substring/&&/outof|substring/&&/invalid',
'outofstackmemory','stack/&&/exceed|stack/&&/outof|stack/&&/limit',
'overflow','overflow|toolarge|toobig|exceed',
'overflowcondition','overflow|toolarge|toobig|exceed',
'readpastend-of-file','file/&&/end',
'readpastend-of-record','read/&&/end/&&/record|read/&&/long/&&/record|read/&&/length/&&/record|read/&&/size/&&/record',
'readrecordnumberoutofrange','record/&&/number/&&/outof/&&/range|bad/&&/record/&&/number|record/&&/number/&&/zero|record/&&/number/&&/positive|exist/&&/record',
'reallocdanglingpointer','dangling/&&/pointer|duplicate/&&/free|freed',
'reallocincorrectpointer','realloc/&&/dangling/&&/pointer|realloc/&&/incorrect/&&/pointer|free/&&/incorrect/&&/pointer|free/&&/loca
l|free/&&/global|free/&&/body|free/&&/unallocatedblock|free/&&/notallocated|freed',
'reallocuninitializedpointer','realloc/&&/uninitiali/&&/pointer|realloc/&&/unassigned/&&/pointer|realloc/&&/notinitiali/&&/pointer|free/&&/uninitiali/&&/pointer|free/&&/unassigned/&&/pointer|free/&&/notinitialized/&&/pointer|realloc/&&/undefined/&&/pointer|free/&&/undefined/&&/pointer',
'referencetounallocatedmemory','unallocated/&&/memory|notallocated/&&/memory|writ/&&/overflow',
'streamnotopen','stream/&&/notopen|uninitiali|unassigned|dangling|undefined',
'stringnotnull-terminated','string/&&/not/&&/null',
'thefiledoesnotexist','file/&&/notexist|nosuch/&&/file',
'thefileisalreadyconnected','file/&&/already/&&/connected',
'totalarraysize','actual/&&/dummy/&&/size|size/&&/conflict|size/&&/mismatch|actual/&&/dummy/&&/small',
'typeconflict','type/&&/conflict|type/&&/mismatch|actual/&&/dummy/&&/type|actual/&&/dummy/&&/instead',
'unallocatedarrayorpointer','unallocated/&&/array/&&/deallocat|notallocated/&&/array/&&/deallocat',
'unallocatedarray','unallocated/&&/array/&&/deallocat|notallocated/&&/array/&&/deallocat',
'underflow','underflow|overflow|toolarge|toobig|toosmall|exceed',
'underflowcondition','underflow|overflow|toolarge|toobig|toosmall|exceed',
'uninitialized','uninitiali|unassigned|undefined|wild/&&/pointer',
'uninitializedvariable','uninitiali|unassigned|undefined|wild/&&/pointer',
);

#foreach $k ( keys %TRANSLATION ) {
# $tmp    =  $TRANSLATION{$k} ;
# print "$k               $tmp \n";
#}

# To fix a poroblem wehere a substring was being subsitutetd for before the longer
# substitution; order keys to decending order of length.
@A=keys %TRANSLATION;
# Find longest length
$maxlen=0;
foreach $k (@A) {
  if ( length($k) > $maxlen ) { $maxlen=length($k);}
}
# For leach length from $maxlength to 1, scan @A for keys of that length and append them to @B
# Afer this, B has the keys of %TRANSLATION in desecending order of length.
$pos=0;
foreach $mlen (0..$maxlen-1) {
 $tlen=$maxlen-$mlen;
 foreach $k (@A) {
  if ( length($k) == $tlen) { $pos++;$B[$pos]=$k;}
 }
}
while(<>) {
# foreach $k ( keys %TRANSLATION ) {
# Use @B for the keys of %TRANSLATION to get descending order of length, hence correct translation.
# test1
 chop;
 $extra_string = "";
 if ( /\|anerrorfound/ ) { s/\|anerrorfound//g;$extra_string='|anerrorfound'; }
 foreach $k ( @B ) {
   $t=$TRANSLATION{$k} ;
   if ( ! ( /[\&\|]/ ) ) {s/$k/$t/;}
 }
 $_ .= $extra_string . "\n";
 print;
}

