/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_1_1_h_i.cpp

     Summary:           read an uninitialized variable

     Test description:  the uninitialized variable is a default member variable; the read is in the destructor; "int" is used for the uninitialized variable

     Error line:        55

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          read, default member variable, destructor, uninitialized variable

     Last modified:     10/14/2005 10:08

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the uninitialized variable
        int varA;

    public:
        ~TestClass();
};

TestClass::~TestClass() {
    // varB is used to store the value of varA
    int varB=23;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        varA=rand();
    }

    // varA is still uninitialized
    cout << "read" << endl;

    // this is where the read occurs
    varB=varA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varB << endl;
    }
}

int main() {
    TestClass testclassA;
    return EXITCODE_OK;
}
