/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_1_1_p_d.cpp

     Summary:           read an uninitialized variable

     Test description:  the uninitialized variable is declared in the main function and passed as a value argument to the member function "run"; the read is in the member function "run"; "double" is used for the uninitialized variable

     Error line:        71

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          passing, read, argument, uninitialized variable

     Last modified:     10/14/2005 10:08

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
    public:
        void runA(double varA);
};

void TestClass :: runA(double varA) {
    // varB is used to store the value of varA
    double varB;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        varA=rand();
    }

    // varA is still uninitialized
    cout << "read" << endl;

    // this is where the read occurs
    varB=varA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varB << endl;
    }
}

int main() {
    TestClass testclassA;
    // this is the declaration of the uninitialized variable
    double varA;
    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        varA=rand();
    }

    testclassA.runA(varA);
    return EXITCODE_OK;
}
