/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_2_1_e_l.cpp

     Summary:           read an uninitialized dynamically allocated variable

     Test description:  the pointer to the variable is a default member variable; the allocation is in the constructor; the read is in a friend function; "long" is used for the variable

     Error line:        70

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          allocation, constructor, friend function, read, default member variable, destructor, uninitialized variable

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
        friend void runA();
        // this is the declaration of the pointer for the uninitialized variable
        long *varA;

    public:
        TestClassData();
        ~TestClassData();
};

TestClassData :: TestClassData() {
    cout << "the allocation of varA" << endl;

    // here is the allocation without setting a value
    varA=new long;
}

TestClassData :: ~TestClassData() {
    // the deallocation of varA
    delete varA;
}

TestClassData classdataA;

// this is the friend function
void runA() {
    // varB is used to store the value of varA
    long varB;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        *classdataA.varA=rand();
    }

    // this is where the read occurs
    cout << "read" << endl;
    varB=*classdataA.varA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varB << endl;
    }
}

int main() {
    runA();
    return EXITCODE_OK;
}
