/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_2_1_p_d.cpp

     Summary:           read an uninitialized dynamically allocated variable

     Test description:  the pointer to the variable is declared in the main function and passed as a value argument to the template member function "run"; the allocation is in the main function; the read is in a template function; "double" is used for the variable

     Error line:        69

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          allocation, argument, passing, read, template, main function, uninitialized variable

     Last modified:     10/08/2005 09:08

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
    public:
        template <class T> void runA(T varA);
};

template <class T> void TestClass :: runA(T varA) {
    // varB is used to store the value of varA
    T varB;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        varA=rand();
    }

    // this is where the read occurs
    cout << "read" << endl;
    varB=varA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varB << endl;
    }
}

int main() {
    TestClass testclassA;
    // this is the declaration of the pointer for the uninitialized variable
    double *varA;

    cout << "the allocation of varA" << endl;

    // here is the allocation without setting a value
    varA=new double;

    testclassA.runA(*varA);

    // the deallocation of varA
    delete varA;
    return EXITCODE_OK;
}
