/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_2_2_a_i.cpp

     Summary:           read an entry of an uninitialized dynamically allocated array

     Test description:  the pointer to the array is a default member variable; the allocation is in the constructor; the read is in a member function; "int" is used for the variable

     Error line:        77

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          allocation, array, constructor, member function, read, default member variable, destructor, uninitialized variable

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef SIZE
#define SIZE 100
#endif

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
        // this is the declaration of the pointer for the uninitialized array
        int *arrayA;

    public:
        TestClass();
        ~TestClass();
        void runA();
};

TestClass :: TestClass() {
    cout << "the allocation of the array" << endl;

    // here is the allocation
    arrayA=new int [SIZE];
}

TestClass :: ~TestClass() {
    // the deallocation
    delete [] arrayA;
}

void TestClass :: runA() {
    // varB is used to store a value of arrayA
    int varB=0;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        for ( int i=0; i < SIZE; i++) {
            arrayA[i]=rand();
        }
    }

    // the elements of arrayA are still uninitialized
    cout << "read" << endl;

    // this is where the read occurs
    int i=SIZE/2;
    cout << "read arrayA[" << i << ']' << endl;
    varB=arrayA[i];

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varB << endl;
        for ( int i=0; i < SIZE; i++) {
            cout << arrayA[i] << endl;
        }
    }
}

int main() {
    TestClass testclassA;
    testclassA.runA();
    return EXITCODE_OK;
}
