/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_3_1_f_d.cpp

     Summary:           read a variable by using an uninitialized pointer

     Test description:  the uninitialized pointer is a default member variable; the read is in a friend function; "double" is used for the variable

     Error line:        58

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          read, default member variable, friend function, uninitialized pointer

     Last modified:     10/14/2005 10:15

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClassData {
    private:
        friend void runA();
        // this is the declaration of the pointer
        double *ptrA;
};

// this is the friend function
void runA() {
    TestClassData classdataA;

    // varA is used to store the value that ptrA points to
    double varA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        classdataA.ptrA=(double*) rand();
    }

    // ptrA is not initialized
    cout << "read by using ptrA" << endl;

    // ptrA is not initialized yet
    // this is where the read occurs
    varA=*classdataA.ptrA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varA << endl;
    }
}

int main() {
    runA();
    return EXITCODE_OK;
}
