/*
********************************************************************************
     Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle, James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, and Ziyu Zhang, All rights reserved.  Licensed under the Educational Community License version 1.0.  See the full agreement at http://rted.public.iastate.edu.
  
     Name of the test:  C_A_3_1_p_d.cpp

     Summary:           read a variable by using an uninitialized pointer

     Test description:  the uninitialized pointer is declared in the main function and passed as a pointer argument to the member function "run"; the read is in the member function "run"; "double" is used for the variable

     Error line:        53

     Support files:     Not needed

     Env. requirements: Not needed

     Keywords:          passing, pointer, read, argument, uninitialized pointer

     Last modified:     07/08/2005 15:27

     Programmer:        Andre Wehe, Iowa State University

********************************************************************************
*/

#include <iostream.h>
#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

class TestClass {
    public:
        void runA(double **ptrA);
};

void TestClass :: runA(double **ptrA) {
    // varA is used to store the value that ptrA points to
    double varA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        *ptrA=(double*) rand();
    }

    // ptrA is not initialized
    cout << "read by using ptrA" << endl;

    // ptrA is not initialized yet
    // this is where the read occurs
    varA=**ptrA;

    // outsmart dead code elimination
    if ( 10.0 * rand() / (RAND_MAX + 1.0) > 10) {
        cout << "this should never be called" << endl;
        cout << varA << endl;
    }
}

int main() {
    TestClass testclassA;
    // this is the declaration of the pointer
    double *ptrA;
    testclassA.runA(&ptrA);
    return EXITCODE_OK;
}
