/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_10_a.c
*
*    Test description:	Use an uninitialized variable in expressions 
*			when implicit type conversion is needed.
*			Promote char to int.
*
*    Error line:        45
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			main function
*                       implicit type conversion
*                       promote char to int
*
*    Last modified:	June 22, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   char varA;
   int varB = 0;
    
   ret();
   if(ret1 != 1) varA = 'A';           /* the value of ret1 = 1 */

   varB = varB + varA;        /* promote char to int */ 

   if(ret2!=1) printf("%d", varB);     /* the value of ret2 = 1 */

   return EXITCODE_OK; 
}
