/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_1_a_in.c
*
*    Test description:	Read an uninitialized stack variable in a block.
*
*    Error line:        45
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*                       stack variable
*			main function
*			block  
*			int
*
*    Last modified:	May 31, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
    int varA = 0, b = 0;
    
/* Read an uninitialized variable in a block */
    {   
      int varA;
      ret();
      if(ret1 != 1) varA = 0;  /* the value of ret1 = 1 */
      b = b + varA;      /* the variable varA is uninitialized */
    }

   if(ret2==0) {                  /* the value of ret2 = 1 */
      printf("Variable b=%d", b);
   } 
   
   return EXITCODE_OK; 
}
