/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_1_b_in.c
*
*    Test description:	Read an uninitialized stack variable in a structure.
*
*    Error line:        46
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			stack variable
*			main function
*			structure
*			int
*
*    Last modified:	May 25, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   int b;
   struct aab {
       char * name[5];
       int varA;
   } ss;
    
   ret();
   if(ret1 != 1) ss.varA = 0;  /* the value of ret1 = 1 */
   b = b + ss.varA;      /* the variable ss.varA is uninitialized */

   if(ret2==0) {                  /* the value of ret2 = 1 */
      printf("Variable b=%d", b);
   } 

   return EXITCODE_OK;
}
