/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_1_e_sc.c
*
*    Test description:	Declare a stack variable in main function,
*			pass it by pointer to a function,
*			and read it there uninitialized.
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H, c_A_1_e_sc_s.c
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			stack variable
*			function
*			signed char
*
*    Last modified:	May 31, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int func(signed char *ptrA, int ret1);

int main(void)
{
   signed char varA, c = 'A';
   signed char *ptrA = &varA;
   int b;

/* Read an uninitialized variable in a function */

   ret();
   if(ret1 != 1) ptrA=&c;      /* the value of ret1 = 1 */

   if(ret2 != 1) varA = 'B';  /* the value of ret1 = 2 */
   b = func(ptrA, ret1);
    
   if(b!=1) printf("Variable b=%c", b);
 
   return EXITCODE_OK;
}
