/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_7_a_in.c
*
*    Test description:	Read using an uninitialized pointer in a block.
*
*    Error line:        46
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			uninitialized pointer
*			main function
*			block
*			read
*			int
*
*    Last modified:	June 2, 2005   
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
    int a = 0, b = 0, *ptrA = &b;

/* Read from an uninitialized pointer in a block */
    {
       int *ptrA;
       ret();
       if(ret1==0) ptrA = &a;
       b = b + *ptrA;  /* the pointer ptrA is uninitialized */
    }

    if(ret2==0) printf("Variable b=%d", b); 

    return EXITCODE_OK; 
}
