/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_3_2_a.c
*
*    Test description:	Read one element past the upper bound of
*			a variable-length array	using an array of indexes. 
*			The array is declared and used in a function.
*			The file must be compiled with file c_K_3_2_a.c
*
*    Error line:        42
*
*    Keywords:		out-of-bounds
*			variable-length array
*			array indexing
*			function
*			C99 specific
*			C only
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	June 5, 2005
*/

#include "TEST_PARAM.H"

void func(int dim)
{
    int arrayA[dim], varA;
    int i, index[N];
    
    for(i=0; i<N; i++)
        index[i] = dim-i;
    for(i=0; i<dim; i++) arrayA[i] = i;
    varA = arrayA[index[0]] - dim;  /* read one element past the upper bound */

    ret();
    if(ret1!=1) printf("Variable varA=%d", varA);
    if(ret2!=1) {for(i=0;i<dim;i++) printf("arrayA[%d]=%d",i,arrayA[i]); }
}

