/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_4_1_g.c
*
*    Test description:	Read K elements past the upper bound of a stack array
*			using a subscript. The array is declared and used
*			in an inline function.
*
*    Error line:        48
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			stack array
*			inline function
*			C99 specific
*			read
*                       int
*
*    Last modified:	July 7, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

inline void func(void)
{
   int arrayA[N], varA;
   int i;

   for(i=0; i<N; i++)
       arrayA[i] = i;
   i = i + K - 1;
   varA = arrayA[i];  /* read K elements past the upper bound */

   ret();
   if(ret1!=1) printf("Variable varA=%d", varA);
   if(ret2!=1) {for(i=0;i<N;i++) printf("arrayA[%d]=%d",i,arrayA[i]); }
}

int main(void)
{
    func();
    return EXITCODE_OK;
}

