/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_4_3_c.c
*
*    Test description:	Read one element past the second dimension bound 
*			but within a multidimensional stack array.
*			The array is declared and used in an inline function.
*
*    Error line:        54
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			multidimensional array
*			inline function
*			C99 specific
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 7, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

inline void func(void)
{
   int arrayA[N][N], varA;
   int i, j;

   for(i=0; i<N; i++) {
       for(j=0; j<N; j++)
           arrayA[i][j] = i+j;
        }

/* read one element past the second dimension bound */

   varA = arrayA[0][j]; 

   ret();
   if(ret1!=1) printf("Variable varA=%d", varA);
   if(ret2!=1) {for(j=0;j<N;j++) printf("arrayA[0][%d]=%d",j,arrayA[0][j]); }
}

int main(void)
{
    func();
    return EXITCODE_OK;
}

