/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_K_4_4_f.c
*
*    Test description:	Write K elements before the lower bound of 
*			a dynamically allocated array using a subscript.
*			The array is declared and used in an inline function.
*
*    Error line:        58
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			inline function
*			C99 specific
*			write
*                       int
*
*    Last modified:	July 7, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

inline void func(void)
{
   int *ptrA;
   int i;

   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
       ptrA[i] = i;
   i = i - N - K;
   ptrA[i] = N*i;  /* write K elements before the lower bound */

   ret();
   if(ret2!=1) {for(i=0;i<N;i++) printf("ptrA[%d]=%d",i,ptrA[i]); }
   free(ptrA);
}

int main(void)
{
    func();
    return EXITCODE_OK;
}

