/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_1_1_a.c
*
*    Test description:	Deallocate memory that has never been allocated. 
*                       Call free() in main function; use an uninitialized pointer.
*
*    Error line:        39
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory deallocation error
*                       free uninitialized pointer
*                       main function
*			free()
*                       int
*
*    Last modified:	June 29, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   int *ptrA;

   free(ptrA);  /* deallocate uninitialized pointer */

   ret();
   if(ret2!=1) printf("Error test!");     /* the value of ret2 = 1 */

   return EXITCODE_OK; 
}
