/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_1_2_c.c
*
*    Test description:	Deallocate memory twice.
*                       Allocate memory in main function using a global pointer,
*                       then deallocate it in two functions.
*
*    Support files:     c_G_1_2_c_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		deallocate memory twice
*                       function
*                       global pointer
*			free()
*			int
*
*    Last modified:	June 30, 2005
*/

#include <stdio.h>
#include <stdlib.h>
#include "TEST_CONST.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int *ptrA;

void func_1();
void func_2();

int main(void)
{
   int i;

   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   

   for(i=0;i<N;i++) ptrA[i] = N - i;
   func_1();
   func_2();

   return EXITCODE_OK;
}


