/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_1_3_c.c
*
*    Test description:	Deallocate memory with a global pointer
*                       pointing a few elements before the memory block. 
*                       Move the pointer in a function.
*
*    Error line:        64
*
*    Support files:     c_G_1_3_c_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		deallocate memory with incorrect pointer
*                       function
*                       moved pointer
*                       global pointer
*			free()
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int *ptrA;

void func();

int main(void)
{
   int sum = 0;
   int i;

   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   

   for(i=0;i<N;i++) ptrA[i] = N - i;
   for(i=0;i<N;i++) sum = sum + ptrA[i];
   func();
    
   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */

   free(ptrA);
   return EXITCODE_OK;
}


