/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_2_1_a.c
*
*    Test description:	Reallocate memory that has never been allocated. 
*                       Call realloc() in main function; use an uninitialized pointer.
*
*    Error line:        45
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory reallocation error
*                       realloc uninitialized pointer
*                       main function
*			realloc()
*                       int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
   int *ptrA;

/* reallocate memory that has never been allocated */

   ptrA = (int *)realloc(ptrA, N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   free(ptrA);
   ret();
   if(ret2!=1) printf("Error test!\n");     /* the value of ret2 = 1 */

   return EXITCODE_OK; 
}
