/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_2_1_c.c
*
*    Test description:	Reallocate memory that has never been allocated. 
*                       Call realloc() in a function using a pointer
*                       pointed to global memory.
*
*    Error line:        54
*
*    Support files:     Not needed
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory reallocation error
*                       reallocate memory with incorrect pointer
*                       realloc global memory
*                       function
*			realloc()
*                       int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int arrayA[N];

int func(void)
{
    int *ptrA;
    int i;

    ptrA = arrayA;
    for(i=0; i<N; i++) ptrA[i] = N - i;
    ret();
    if(ret2 != 1) {                   /* the value of ret2 = 1 */
      for(i=0; i<N; i++) printf("%d", ptrA[i]);
     }
   ptrA = (int *)realloc(ptrA, N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   free(ptrA);  

   return EXITCODE_OK;
}

int main(void)
{
    return func();
}


