/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_G_2_2_c.c
*
*    Test description:	Reallocate memory  memory that has been freed. 
*                       Allocate memory in main function using a global pointer,
*                       deallocate it in function_1,
*                       and reallocate it in function_2.
*                       The file must be compiled with file c_G_2_2_c.c
*
*    Error line:        52
*
*    Keywords:		memory reallocation error
*                       reallocate freed memory
*                       function
*                       freed pointer
*			realloc()
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int *ptrA;

void func_1()
{
   int sum = 0;
   int i;

   for(i=0;i<N;i++) sum = sum + ptrA[i];

   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */
    
   free(ptrA);
}

void func_2()
{
   ptrA = (int *)realloc(ptrA, K*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   free(ptrA);
}

