/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_1_2_b.c
*
*    Test description:	Write one element before the lower bound of a stack array
*			using a subscript. The array is declared and used in a function.
*			The file must be compiled with file c_E_1_2_b.c
*
*    Error line:        39
*
*    Keywords:		out-of-bounds
*			array indexing
*			stack array
*			function
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 28, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int arrayA[N], c = 0, sum = 0;
   int i;

   for(i=0; i<N; i++)
       arrayA[i] = i;
   i = i - N - 1;
   arrayA[i]  = c;  /* write one element before the lower bound */
   for(i=0; i<N; i++)
       sum = sum + arrayA[i];

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

