/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_1_4_a.c
*
*    Test description:	Write one element past the upper bound of 
*			a single-dimensional stack array in a block.
*			Use array indexing.
*
*    Error line:        51
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			stack array
*			main function
*			block
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 28, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
    int a = 0, sum = 0; 
    int i;

    {
      int arrayA[N];
      for(i=0; i<N; i++)
          arrayA[i] = i;
      arrayA[i] = a;     /* write one element past the upper bound */
      for(i=0; i<N; i++)           
          sum = sum + arrayA[i];    
    }

   ret();
   if(ret2==0) {                  /* the value of ret2 = 1 */
     printf("Variable sum=%d", sum);
   } 
   
   return EXITCODE_OK; 
}
