/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_2_4_c.c
*
*    Test description:	Write one element past the upper bound of a stack array
*			using an array of indexes. The array is passed to a function.
*			The file must be compiled with file c_E_2_4_c.c
*
*    Error line:        37
*
*    Keywords:		out-of-bounds
*			stack array
*			array indexing
*			function
*			fence-post error
*			off-by-one error
*			write
*
*    Last modified:	July 28, 2005
*/

#include "TEST_PARAM.H"

int func(int *arrayA)
{
   int c = 0, sum = 0;
   int i, index[N];
    
   for(i=0; i<N; i++)
        index[i] = N-i;
   arrayA[index[0]] = c;  /* write one element past the upper bound */
   for(i=0; i<N; i++)
       sum = sum + arrayA[i];

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

