/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_3_2_a.c
*
*    Test description:	Write one element before the lower bound of  
*			a multidimensional stack array.
*			Declare and use the array in a block.
*
*    Error line:        54
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			stack array
*			multidimensional array
*			main function
*			block
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 29, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   int a = 0, sum = 0;
   int i, j;

   {
    int arrayA[N][N];
    for(i=0; i<N; i++) {
        for(j=0; j<N; j++)
            arrayA[i][j] = i+j;
        }
    j = j - N - 1;
    arrayA[0][j] = a;  /* write one element before the lower bound */
    for(i=0; i<N; i++)              /* use elements of the array */
        sum = sum + arrayA[0][i];   /* to prevent code elimination */ 
   }
   
   ret();
   if(ret2==0) {                  /* the value of ret2 = 1 */
     printf("Variable sum=%d", sum);
   } 
   
   return EXITCODE_OK; 
}
