/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_3_3_c.c
*
*    Test description:	Read one element past the second dimension bound but within
*			a multidimensional stack array.
*			The array is declared in main function
*			and passed to a function as an argument.
*
*    Support files:     c_E_3_3_c_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			array indexing
*			multidimensional array
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 29, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include <stdio.h> 
#include "TEST_CONST.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int func(int arrayA[N][N], int i);

int main(void)
{
   int a, arrayA[N][N];
   int i, j;

   for(i=0; i<N; i++) {
       for(j=0; j<N; j++)
           arrayA[i][j] = i+j;
       }

   a = func(arrayA,j);

   if(a!=1) printf("Variable a=%d", a);
   
   return EXITCODE_OK;
}
