/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_3_8_c.c
*
*    Test description:	Write K elements past the upper bound of
*			a multidimensional stack array.
*			The array is declared in main function
*			and passed to a function as an argument.
*			The file must be compiled with file c_E_3_8_c.c
*
*    Error line:        35
*
*    Keywords:		out-of-bounds
*			array indexing
*			multidimensional array
*			function
*			write
*                       int
*
*    Last modified:	July 29, 2005
*/

#include "TEST_PARAM.H"

int func(int arrayA[N][N], int i)
{
   int c = 0, sum = 0;

   arrayA[N-1][i] = c;  /* write K elements past the upper bound */

   for(i=0; i<N; i++)              /* use elements of the array */
       sum = sum + arrayA[N-1][i];   /* to prevent code elimination */ 

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

