/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_4_2_c.c
*
*    Test description:	Write one element before the lower bound of 
*			a dynamically allocated array using a subscript.
*			The array is declared in main function and 
*			passed to a function as an argument.
*			The file must be compiled with file c_E_4_2_c.c
*
*    Error line:        37
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			function
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 29, 2005
*/

#include "TEST_PARAM.H"

int func(int *ptr, int i)
{
   int c = 0, sum = 0;

   ptr[i] = c;  /* write one element before the lower bound */
   for(i=0; i<N; i++)
       sum = sum + ptr[i];

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

