/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_E_5_2_d.c
*
*    Test description:	Write one element before the lower bound of 
*			a dynamically allocated multidimensional array 
*			that is a member of a structure declared in a function. 
*			Use array indexing.
*			The file must be compiled with file c_E_5_2_d.c
*
*    Error line:        67
*
*    Keywords:		out-of-bounds
*			array indexing
*			dynamically allocated array
*			multidimensional array
*			function
*			structure
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 30, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(void)
{
   int b = 0, sum = 0;
   int i, j;
   struct aab {
       char * nm;
       int **ptr;
   } ss;

   ss.ptr = (int **)malloc(N*sizeof(int *));
   if(!ss.ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
    {
       ss.ptr[i] = (int *)malloc(N*sizeof(int));
       if(!ss.ptr[i])
        { 
          printf("Out of memory.\n");
          exit(EXITCODE_ERROR);
        }   
    }
   for(i=0; i<N; i++)
       for(j=0; j<N; j++)
           ss.ptr[i][j] = i+j;
   j = j - N - 1;
   ss.ptr[0][j] = b;  /* write one element before the lower bound */
   for(i=0; i<N; i++)            /* use elements of the array */
       sum = sum + ss.ptr[1][i];   /* to prevent code elimination */ 

   for(i=0; i<N; i++)
       free(ss.ptr[i]);
   free(ss.ptr);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

