/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_J_1_1_h.c
*
*    Test description:	Out-of-bounds memory access of a global array.
*			Write K elements past the upper bound of a global array
*			in a function. Use array indexing.
*			The file must be compiled with file c_J_1_1_h.c
*
*    Error line:        39
*
*    Keywords:		out-of-bounds
*			array indexing
*			global array
*			function
*			write
*                       int
*
*    Last modified:	July 1, 2005
*/

#include "TEST_PARAM.H"

extern int arrayA[N];

void func(void)
{
   int i;

   for(i=0; i<N; i++)
       arrayA[i] = N-i;
   i = i + K - 1;
   arrayA[i] = N*i;  /* write K elements past the upper bound */

   ret();
   if(ret2!=1) {for(i=0;i<N;i++) printf("arrayA[%d]=%d  ",i,arrayA[i]); }
}
