/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_H_2_a.c
*
*    Test description:	File I/O error. 
*			Read from a file that is closed.
*
*    Error line:        49
*
*    Support files:     file_read.txt, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		file I/O error
*                       read
*
*    Last modified:	June 30, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
   char ch;
   FILE *fp;
    
   if((fp = fopen("file_read.txt", "r"))==NULL)
    {
      printf("Cannot open the file!\n");
      exit(EXITCODE_ERROR);
    }
   fclose(fp);
   ch = fgetc(fp); /* read from a file that is closed */
   ret();
   if(ret1!=1) printf("Variable ch=%c", ch);
    
   return EXITCODE_OK;
}
