/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .
*    Test name:		c_I_1_c.c
*
*    Test description:	Allocate memory twice using the same pointer 
*                       without deallocating it first 
*                       and without associating another pointer   
*                       with the first block of memory. 
*                       Pass a pointer by address to two different functions 
*                       where it is used to allocate memory.
*                       The file must be compiled with file c_I_1_c.c
*
*    Error line:        38
*
*    Keywords:		memory leak
*                       double allocation
*                       unreferenced memory
*			function
*			int
*
*    Last modified:	June 30, 2005
*/


#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int sum;

void func_2(int **ptr)
{
   *ptr = (int *)malloc(sizeof(int));
   if(!*ptr)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   

   **ptr = sum/N;
    
   ret();
   if(ret2!=1) printf("%d\n", **ptr);     /* the value of ret2 = 1 */
}
