/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt . */
/*
*    Test name:		c_I_2_b.c
*
*    Test description:	Reset a pointer pointing to a block of memory 
*                       to point somewhere else 
*                       leaving the first block of memory unreferenced.   
*                       Use a pointer in a function to allocate memory,
*                       then reset it in main function to point to another
*                       block of memory.
*                       The file must be compiled with file c_I_2_b.c
*
*    Keywords:		memory leak
*                       unreferenced memory
*			reset a pointer
*			function
*			int
*
*    Last modified:	June 30, 2005
*/

#include "TEST_CONST.H"
#include <stdlib.h>
#include <stdio.h>

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int *func(void)
{
   int *ptrB;
   int i;

   ptrB = (int *)malloc(N*sizeof(int));
   if(!ptrB)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrB[i] = N - i;
 
   return(ptrB);    
}
