/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_3_c.c
*
*    Test description:	Allocate a block of memory and deallocate only part of it.
*                       Use a global pointer; allocate memory and move the pointer
*                       in two different functions; deallocate memory in main function.
*
*    Error line:        43
*
*    Support files:     c_I_3_c_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		memory leak
*                       global pointer
*			function
*			int
*
*    Last modified:	June 30, 2005
*/

#include <stdlib.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

void func_1(void);
void func_2(void);

int *ptrA;
int sum = 0;

int main(void)
{
   func_1();
   func_2();
   free(ptrA);
     
   return EXITCODE_OK;
}
