/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt .*/
/*
*    Test name:		c_I_3_c.c
*
*    Test description:	Allocate a block of memory and deallocate only part of it.
*                       Use a global pointer; allocate memory and move the pointer
*                       in two different functions; deallocate memory in main function.
*                       The file must be compiled with file c_I_3_c.c
*
*    Keywords:		memory leak
*                       global pointer
*			function
*			int
*
*    Last modified:	June 30, 2005
*/


#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int *ptrA;
extern int sum;

void func_1(void)   /* allocate mamory */
{
   int i;

   ptrA = (int *)malloc(N*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0;i<N;i++) ptrA[i] = N - i;
   for(i=0;i<N;i++) sum = sum + ptrA[i];

   ret();
   if(ret1!=1) printf("%d\n", sum);     /* the value of ret1 = 1 */
}

void func_2(void)    /* move the pointer */
{
   ptrA+=K;
   if(ret2!=1) printf("%d\n", *ptrA);     /* the value of ret2 = 1 */
}
