/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_1_1_c.c
*
*    Test description:	Read one element before the lower bound of 
*			a single-dimensional stack array declared in main function
*			and passed by another pointer to a function where it is used.
*			The file must be compiled with file c_F_1_1_c.c
*
*    Error line:        38
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			stack array
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

int func(int *ptr)
{
   int c;
   ptr--;
   c = *ptr;  /* read one element before the lower bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable c=%d", c);
   } 

   return ret2;
}
