/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_1_2_b.c
*
*    Test description:	Write one element before the lower bound of 
*			a single-dimensional stack array declared and used 
*			in a function. Use pointer reference.
*			The file must be compiled with file c_F_1_2_b.c
*
*    Error line:        45
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			stack array
*			function
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

int func(void)
{
   int arrayA[N], c = 0, *ptr, sum = 0; 
   int i;

   for(i=0; i<N; i++)
       arrayA[i] = i;
   ptr = arrayA;
   for(i=0; i<N; i++)      /* use elements of the array */
       sum = sum + ptr[i];   /* to prevent code elimination */ 
   ptr--;
   *ptr = c;  /* write one element before the lower bound */

   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}
