/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_2_2_f.c
*
*    Test description:	Write one element before the lower bound of 
*			a dynamically allocated array.
*			Use a global pointer initially set to point to the array
*                       and then moved outside the bounds.
*			The array is declared and used in a function.
*			The file must be compiled with file c_F_2_2_f.c
*
*    Error line:        58
*
*    Keywords:		out-of-bounds
*			pointer reference
*			dynamically allocated array
*			global pointer
*			function
*			fence-post error
*			off-by-one error
*			write
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

extern int *ptr;

int func(void)
{
   int *arrayA, b = 0, sum = 0;
   int i;

   arrayA = (int *)malloc(N*sizeof(int));
   if(!arrayA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
       arrayA[i] = i;
   ptr = arrayA;
   for(i=0; i<N; i++)        /* use elements of the array */
       sum = sum + ptr[i];   /* to prevent code elimination */ 
   ptr--;
   *ptr = b;  /* write one element before the lower bound */

   free(arrayA);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable sum=%d", sum);
   } 

   return ret2;
}

