/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_2_3_b.c
*
*    Test description:	Read one element past the upper bound of 
*			a dynamically allocated array.
*			Use another pointer initially set to point to the array
*                       and then moved outside the bounds.
*			The array is declared and used in a function.
*			The file must be compiled with file c_F_2_3_b.c
*
*    Error line:        53
*
*    Keywords:		out-of-bounds
*			pointer reference
*			dynamically allocated array
*			function
*			fence-post error
*			off-by-one error
*			read
*                       int
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(void)
{
   int *arrayA, *ptr, b;
   int i;

   arrayA = (int *)malloc(N*sizeof(int));
   if(!arrayA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   for(i=0; i<N; i++)
       arrayA[i] = i;
   ptr = arrayA;
   ptr+=N;
   b = *ptr;  /* read one element past the upper bound */

   free(arrayA);
   ret();
   if(ret1==0) {               /* the value of ret1 = 1 */
      printf("Variable b=%d", b);
   } 

   return ret2;
}

