/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_F_2_8_a.c
*
*    Test description:	Write K elements past the upper bound of 
*			a dynamically allocated array in a block.
*			Use another pointer initially set to point to the array
*                       and then moved outside the bounds.
*
*    Error line:        65
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		out-of-bounds
*			pointer reference
*			dynamically allocated array
*			main function
*			block
*			write
*                       int
*
*    Last modified:	July 31, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
   int a = 0, *ptr, sum = 0; 
   int i;

   {
     int *arrayA;
     
     arrayA = (int *)malloc(N*sizeof(int));
     if(!arrayA)
      { 
        printf("Out of memory.\n");
        exit(EXITCODE_ERROR);
      }   
     for(i=0; i<N; i++)
         arrayA[i] = i;
     ptr = arrayA;
     for(i=0; i<N; i++)           /* use elements of the array */
         sum = sum + ptr[i];      /* to prevent code elimination */ 
     ptr+=(N+K-1);
     *ptr = a;  /* write K elements past the upper bound */
     
     free(arrayA);
   }

   ret();
   if(ret2==0) {                  /* the value of ret2 = 1 */
     printf("Variable sum=%d", sum);
   } 
   
   return EXITCODE_OK; 
}
