/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt . */
/*
*    Test name:		c_J_3_2_b.c
*
*    Test description:	Access deallocated memory.
*                       Point a pointer to an allocated array,
*                       then deallocate the memory and try to write into it 
*                       using the pointer.
*
*    Error line:        58
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		access deallocated memory
*                       pointer reference
*                       dangling pointer
*                       write
*                       main
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
   int *arrayA, *ptrA, varA = 0;
   int i;

   arrayA = (int *)malloc(N*sizeof(int));
   if(!arrayA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   

   for(i=0;i<N;i++) arrayA[i] = N - i;
   ptrA = arrayA;
   ret();
   if(ret1!=1) {for(i=0;i<N;i++) printf("arrayA[%d]=%d  ",i,arrayA[i]); }

   free(/*DEALLOC*/arrayA); 

   *ptrA = varA;   /* read from deallocated array */
   if(ret2!=1) printf("Variable ptrA=%d", *ptrA);

   return EXITCODE_OK;
}


