/*   Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
  and Ziyu Zhang, All rights reserved.
  Licensed under the Educational Community License version 1.0.
  See the full agreement at http://rted.public.iastate.edu/license.txt . */
/*
*    Test name:		c_J_3_3_b.c
*
*    Test description:	Access deallocated memory.
*                       Point a pointer to a local array in a block,
*                       then try to write to the memory after exit the block 
*                       using the pointer.
*
*    Error line:        49
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*
*    Env. requirement:  Not needed
*
*    Keywords:		access deallocated memory
*                       pointer reference
*                       dangling pointer
*                       block
*                       write
*                       main
*
*    Last modified:	July 31, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
  int *ptrA, varA = 0;
  int i;

  { 
   int arrayA[N];
   for(i=0;i<N;i++) arrayA[i] = N - i;
   ptrA = arrayA;
   ret();
   if(ret1!=1) {for(i=0;i<N;i++) printf("arrayA[%d]=%d  ",i,ptrA[i]); }
  }
  
  *ptrA = varA;   /* write to deallocated memory */
  if(ret2!=1) printf("Variable varA=%d", *ptrA);

  return EXITCODE_OK;
}


