/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_D_1_7_a.c
*
*    Test description:	Use not null-terminated string as an argument 
*                       of function strlen(str1).
*                       The string is declared in stack memory.
*
*    Error line:        51
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		string
*                       stack memory
*                       read overflow
*                       not null-terminated string
*                       strlen
*
*    Last modified:	June 20, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
  char str1[]="the second string";
  char str2[] = "ifmmp!xpsme";
  int i, len;

  for(i=0; i<sizeof(str1); i++)
      str1[i]='x';
      
  for(i=0; i<strlen(str2); i++)
      str1[i]=str2[i]-1;

  len = strlen(str1);

  ret();
  if(ret1!=1)               /* ret1 = 1 */
     printf ("Length of the string %s is %d\n",str1,len); 
     
  return EXITCODE_OK; 
}
