/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_D_2_5_b.c
*
*    Test description:	Use strcat(str1,str2) when str1 is not long enough  
*                       to hold both str1 and str2.
*                       The strings are dynamically allocated.
*
*    Error line:        65
*
*    Support files:     TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		string
*                       dynamically allocated memory
*                       write overflow
*                       strcat
*
*    Last modified:	June 21, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"
#include <string.h>

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
  char *str1;
  char *str2;
  char str3[]="last string";
  int n=sizeof(str3);

  str1 = (char *)malloc(2*n*sizeof(char));
  if(!str1)
   { 
     printf("Out of memory.\n");
     exit(EXITCODE_ERROR);
   }   
  strcpy(str1,"first string");

  str2 = (char *)malloc(2*n*sizeof(char));
  if(!str2)
   { 
     printf("Out of memory.\n");
     exit(EXITCODE_ERROR);
   }   
  strcpy(str2,"second string");

  strcat(str1,str2);

  ret();
  if(ret1!=1)               /* ret1 = 1 */
     printf ("%s \n",str1); /* use the value to prevent code elimination */
  free(str1);
  free(str2);

  return EXITCODE_OK; 
}
