/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_10_d.c
*
*    Test description:	Use an uninitialized variable in expressions 
*			when implicit type conversion is needed.
*			Promote float to double.
*
*    Error line:        45
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			main function
*                       implicit type conversion
*                       promote float to double
*
*    Last modified:	June 22, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   float varA;
   double varB = 5.0;
    
   ret();
   if(ret1 != 1) varA = 1.0;

   varB = varB + varA;           /* promote float to double */ 

   if(ret2!=1) printf("%f", varB);     /* the value of ret2 = 1 */

   return EXITCODE_OK; 
}
