/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_11_f.c
*
*    Test description:	Pass an uninitialize variable as an argument to a function
*			that does not have a prototype.
*			Promote float to double.
*
*    Error line:        46
*
*    Support files:     c_A_11_f_s.c, index_array.txt, TEST_CONST.H, TEST_PARAM.H 
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			function
*                       automatic argument conversion
*                       promote float to double
*                       C only
*
*    Last modified:	June 22, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

int main(void)
{
   float varA;
   double varB;
    
   ret();
   if(ret1 != 1) varA = 1.0;

   varB = func(varA);
   
   if(ret2!=1) printf("%f", varB);     /* the value of ret2 = 1 */

   return EXITCODE_OK; 
}
