/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_4_b_in.c
*
*    Test description:	Read an uninitialized dynamically allocated array 
*			declared in a structure. Use array indexing.
*
*    Error line:        61
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			dynamically allocated array
*			main function
*			array indexing
*			structure
*			int
*
*    Last modified:	June 1, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int main(void)
{
    int b = 0;
    int i;
    struct aab {
        char * name[5];
        int *ptrA;
    } ss;
    
    ss.ptrA = (int *)malloc(10*sizeof(int));
    if(!ss.ptrA)
     { 
       printf("Out of memory.\n");
       exit(EXITCODE_ERROR);
     }   
    ret();
    if(ret1 != 1) {                   /* the value of ret1 = 1 */
       for(i=0; i<10; i++) ss.ptrA[i] = i;
       }
    b = b + ss.ptrA[5];  
    if(ret2 != 1) {                   /* the value of ret2 = 1 */
       for(i=0; i<10; i++) printf("%d", ss.ptrA[i]);
     }
    free(ss.ptrA);    

    if(ret2==0) printf("Variable b=%d", b); 

    return EXITCODE_OK; 
 }
