/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_5_c_in.c
*
*    Test description:	Read an uninitialized dynamically allocated array 
*			in a function. Use pointer arithmetic.
*			The file must be compiled with file c_A_5_c_in.c
*
*    Error line:        48
*		
*    Keywords:		uninitialized variables
*			dynamically allocated array
*			function
*			pointer arithmetic
*			int
*
*    Last modified:	June 1, 2005
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(void)
{
   int b = 0, *ptrA, *ptrB;
   int i;

   ptrA = (int *)malloc(10*sizeof(int));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   ret();
   if(ret1 != 1) {                   /* the value of ret1 = 1 */
      for(i=0; i<10; i++) ptrA[i] = i;
      }
   ptrB = ptrA;
   b = b + *(ptrB+5); /* read from an uninitialized array */
   if(ret2 != 1) {                   /* the value of ret2 = 1 */
      for(i=0; i<10; i++) printf("%d", ptrA[i]);
    }
   free(ptrA);    
   if(ret2==0) printf("Variable b=%d", b); 
   
   return ret2;
}

