/*
* Copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
* James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu, 
* and Ziyu Zhang, All rights reserved.
* Licensed under the Educational Community License version 1.0.
* See the full agreement at http://rted.public.iastate.edu/ .
*/
/*
*    Test name:		c_A_5_d_sc.c
*
*    Test description:	Read an uninitialized dynamically allocated array 
*			passed to a function. Use pointer arithmetic.
*
*    Support files:     index_array.txt, TEST_CONST.H, TEST_PARAM.H, c_A_5_d_sc_s.c
*    
*    Env. requirements: Not needed
*
*    Keywords:		uninitialized variables
*			dynamically allocated array
*			function
*			pointer arithmetic
*			signed char
*
*    Last modified:	June 1, 2005
*
*    Programmer:        Olga Taborskaia, Iowa State University
*/

#include "TEST_PARAM.H"

#ifndef EXITCODE_OK
#define EXITCODE_OK 1
#endif

#ifndef EXITCODE_ERROR
#define EXITCODE_ERROR 2
#endif

int func(signed char *ptrA, int ret1);

int main(void)
{
   signed char *ptrA, arrayA[]="abc";
   int b, i;
    
   ptrA = (signed char *)malloc(10*sizeof(signed char));
   if(!ptrA)
    { 
      printf("Out of memory.\n");
      exit(EXITCODE_ERROR);
    }   
   ret();
   if(ret1 != 1) {
      ptrA = arrayA;
    }

   b = func(ptrA, ret1); /* pass an uninitialized array to a function */

   if(ret2 != 1) printf("%s", ptrA);         /* the value of ret2 = 1 */
   free(ptrA);    
    
   if(b!=1) printf("Variable b=%d", b); 

   return EXITCODE_OK; 
}
