!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_1_a.f90
!
!     Summary:           allocation/deallocation error
!
!     Test description:  deallocation twice
!                        for allocatable array in a main program
!
!     Support files:     Not needed
!
!     Env. requirements: Not needed
!
!     Keywords:          deallocation error
!                        main program
!                        
!
!     Last modified:     1/17/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************

program tests
  implicit none
  double precision, allocatable :: arr(:,:)  ! DECLARE
  integer :: n=10, m=20
  integer :: i,j

  allocate(arr(n,m))
  do i=1,n
     do j=1,m
        arr(i,j) = dble(i*j)
     enddo
  end do
  print *,arr(n,m)
  deallocate(arr)
  deallocate(arr)   ! deallocate second time here. ERROR 
end program tests
