!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_2_e.f90
!
!     Summary:           allocation/deallocation error
!
!     Test description:  deallocation continuously twice
!                        for pointer in a function which
!                        contains in a main program 
!                        
!
!     Support files:     Not needed
!
!     Env. requirements: Not needed
!
!     Keywords:          deallocation error
!                        function contains in the main program
!                        
!
!     Last modified:     1/17/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************

program tests
  implicit none
  integer :: n=10, m=20
  double precision :: var
  double precision, pointer, dimension(:,:) :: arr1
  allocate(arr1(n,m))
  var = sub(n,m)
  print *,var
  contains
    double precision function sub(n,m)
      integer, intent(in) :: n,m
      double precision, pointer, dimension(:,:) :: arr  ! DECLARE

      integer :: i,j
      do i=1,n
         do j=1,m
            arr1(i,j) = dble(i*j)
         enddo
      end do
      sub = arr1(n,m)
      deallocate(arr)   ! deallocate second time here. ERROR 
      return
    end function sub
end program tests
