!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_2_f.f90
!
!     Summary:           allocation/deallocation error
!
!     Test description:  deallocation continuously twice
!                        for pointer in a function which is
!                        declared outside of the main program 
!                        
!
!     Support files:     Not needed
!
!     Env. requirements: Not needed
!
!     Keywords:          deallocation error
!                        function declared outside the main program
!                        
!
!     Last modified:     1/17/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************
program tests
  implicit none
  interface 
     double precision function sub(n,m)
       implicit none
       integer, intent(in) :: n,m
     end function sub
  end interface

  integer :: n=10, m=20
  double precision :: var

  var =  sub(n,m)
  print *,var
end program tests
   
double precision function sub(n,m)
  integer, intent(in) :: n,m
  double precision, pointer, dimension(:,:) :: arr  ! DECLARE
  double precision, dimension(:,:), allocatable :: arr1
  integer :: i,j
  allocate(arr1(n,m))
  do i=1,n
     do j=1,m
        arr1(i,j) = dble(i*j)
     enddo
  end do
  sub = arr1(n,m)
  deallocate(arr,arr1)   ! deallocate second time here. ERROR 
  return
end function sub
