!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_3_a.f90
!
!     Summary:           allocation/deallocation error
!
!     Test description:  deallocation of allocatable array through
!                        a pointer in the main progran
!                        
!
!     Support files:     Not needed
!
!     Env. requirements: Not needed
!
!     Keywords:          deallocation error
!                        main program
!                        
!
!     Last modified:     1/17/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************

program tests
  implicit none
  double precision, allocatable, target :: arr(:,:)
  double precision, pointer, dimension(:,:) :: ptr  

  integer :: n=10, m=20
  integer :: i,j

  allocate(arr(n,m))
  ptr => arr
  do i=1,n
     do j=1,m
        ptr(i,j) = dble(i*j)
     enddo
  end do
  ptr => arr
  print *,ptr(n,m)
  deallocate(ptr)   ! deallocate through a pointer. ERROR 
  deallocate(arr) 
  print *,i
end program tests
