!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_3_b.f90
!
!     Summary:           allocation/deallocation error
!
!     Test description:  deallocation through a pointer 
!                        for allocatable array in a subroutine
!                        contains in a main program 
!                        
!
!     Support files:     Not needed
!
!     Env. requirements: Not needed
!
!     Keywords:          deallocation error
!                        subroutine contains in a main program
!
!     Last modified:     1/17/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************

program tests
  implicit none
  integer :: n=10, m=20
  double precision :: var

  call sub(n,m,var)
  print *,var
  contains
    subroutine sub(n,m,var)
      integer, intent(in) :: n,m
      double precision, intent(inout) :: var
      double precision, allocatable, target :: arr(:,:)
      double precision, pointer, dimension(:,:) :: ptr

      integer :: i,j
      allocate(arr(1:n,1:m))
      ptr => arr
      do i=1,n
         do j=1,m
            ptr(i,j) = dble(i*j)
         enddo
      end do
      var = ptr(n,m)
      deallocate(ptr)    ! deallocate through a pointer. ERROR 
      deallocate(arr)
      return
    end subroutine sub
end program tests
