!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_4_f.f90
!
!     Summary:           allocation/deallocation error
!
!     Test description:  deallocate an pointer with undefined association status
!                        a pointer in the main progran
!
!     Support files:     Not needed
!
!     Env. requirements: Not needed
!
!     Keywords:          deallocation error
!                        main program
!
!
!     Last modified:     06/01/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************
program tests
  implicit none
  interface 
     double precision function sub(n,m)
       implicit none
       integer, intent(in) :: n,m
     end function sub
  end interface

  integer :: n=10, m=20
  double precision :: var

  var =  sub(n,m)
  print *,var
end program tests
    
double precision function sub(n,m)
  integer, intent(in) :: n,m
  double precision, allocatable, target :: arr(:,:)
  double precision, pointer, dimension(:,:) :: ptr       ! DECLARE 
  
  integer :: i,j
  allocate(arr(1:n,1:m))
  ptr => arr
  do i=1,n
     do j=1,m
        ptr(i,j) = dble(i*j)
     enddo
  end do
  sub = ptr(n,m)
  deallocate(arr)
  deallocate(ptr)    ! deallocate an unassociated pointer ERROR   
  return
end function sub
