!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_5_a.f90
!
!     Summary:           Memory Allocation and Deallocation Errors
!
!     Test description:  deallocate an pointer associated with a target 
!                        that was not  created by a allocation
!                        The error occurs in the main program.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          deallocation errors 
!                        main program
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  integer,parameter :: n=10, m=20
  double precision, target :: arr(n,m)
  double precision, pointer, dimension(:,:) :: ptr  ! DECLARE 

  integer :: i,j

  ptr => arr
  do i=1,n
     do j=1,m
        ptr(i,j) = dble(i*j)
     enddo
  end do
  ptr => arr
  print *,ptr(n,m)
  deallocate(ptr)   ! deallocate second time here. ERROR 
end program tests
