!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_1_5_b.f90
!
!     Summary:           Memory Allocation and Deallocation Errors
!
!     Test description:  deallocate an pointer associated with a target 
!                        that was not  created by a allocation
!                        The error occurs in the internal subroutine.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          deallocation errors 
!                        internal subroutine
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  integer :: n=10, m=20
  double precision :: var

  call sub(n,m,var)
  print *,var
  contains
    subroutine sub(n,m,var)
      integer, intent(in) :: n,m
      double precision, intent(inout) :: var
      double precision,target :: arr(n,m)
      double precision, pointer, dimension(:,:) :: ptr  ! DECLARE 

      integer :: i,j
      ptr => arr
      do i=1,n
         do j=1,m
            ptr(i,j) = dble(i*j)
         enddo
      end do
      var = ptr(n,m)
      deallocate(ptr)   ! deallocate second time here. ERROR 
      return
    end subroutine sub
end program tests
