!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_2_1_c.f90
!
!     Summary:           Memory Allocation and Deallocation Errors
!
!     Test description:  To allocate a currently allocated allocatable array or pointer 
!                        The error occurs in the external subroutine.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          allocation errors 
!                        external subroutine
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  double precision :: var1,var2
  integer :: n=10,m=20

  call sub(n,m,var1,var2)
  print *,'var1=',var1
  print *,'var2=',var2
end program tests
   
 subroutine sub(n,m,var1,var2)
   implicit none
   integer, intent(in) :: m,n
   double precision, intent(inout) :: var1, var2
   
   double precision, target, allocatable :: arr(:,:) ! DECLARE
   double precision, pointer, dimension(:,:) :: ptr
   
   integer :: i,j
   allocate(arr(n,m))
   ptr => arr
   do i=1,n
      do j=1,m
         ptr(i,j) = dble(i*j)
      end do
   end do
   var1 = ptr(n/2,m/2)
   print *,var1
   
   allocate(arr(m,n))   ! allocate arr without deallocate first ERROR
   do i=1,n
      do j=1,m
         arr(j,i) = dble(i+j)
      end do
   end do
   var2 = arr(m/2,n/2)
   print *,var2
   deallocate(arr)
 end subroutine sub
 
