!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_H_3_2_d.f90
!
!     Summary:           Memory Allocation and Deallocation Errors
!
!     Test description:  try to declare sevral very big pointers (heap memory) 
!                        in the procedure 
!                        The error occurs in the internal function.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          heap overflow 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  implicit none
  double precision :: var
  integer :: m
  m=1000000
  var = 0.0
  var = sub(m)
  print *,var
  contains
    double precision function sub(m)
      integer, intent(in) :: m

      double precision, pointer, dimension(:,:) :: ptr
      integer :: i,j

      allocate(ptr(m,m)) ! Heap allocation ERROR occurs here
      do i=1,m
         do j=1,m
            ptr(i,j) = dble(i*j)
         end do
      end do
      sub = ptr(m/2,m/2)
      deallocate(ptr)
      return
    end function sub
end program test
