!***************************************************************************
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_D_1_1_e.f90
!
!     Summary:           non-conforming use of Fortran 90 arrays
!
!     Test description:  use array section to read or write between two arrays
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          non-conforming use of Fortran 90 arrays
!
!     Last modified:     06/06/05
!
!     Programmer:        Ying Xu
!*************************************************************************

program test
  implicit none
  double precision, allocatable :: arr2(:,:)
  double precision, allocatable :: arr1(:)
  double precision :: pi
  integer :: n1,n2, i,j
  
  pi = atan(1.0)
  n1 = int(100*sin(pi/6.0))
  n2 = int(100*sin(0.25*pi))
  print *,'n1,n2',n1,n2
  allocate(arr2(n1,n2),arr1(n1))

  do i=1,n1
     do j=1,n2
        arr2(i,j) = sin(pi*dble(i)/dble(n1))*cos(pi*dble(j)/dble(n2))
     enddo
  end do

   arr2(int(n1/2),1:int(n2/2)) = arr1(1:n1:2)  ! ERROR 
  print *,'arr1(1)',arr1(1)
  deallocate(arr1,arr2)
end program test
