!***************************************************************************
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_D_1_2_a.f90
!
!     Summary:           non-conforming use of Fortran 90 arrays
!
!     Test description:  use array section to read or write between two arrays
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          non-conforming use of Fortran 90 arrays
!
!     Last modified:     06/06/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  implicit none
  double precision, allocatable :: arr2(:,:,:)
  double precision, allocatable :: arr1(:,:)
  double precision :: pi
  integer :: n1,n2, i,j,k

  n1 = 10
  n2 = 22
  print *,'n1,n2',n1,n2
  allocate(arr2(2:n2+1,10:n2+9,-1:n2-2), arr1(n1,-2:n1-3))

  do k=-1,n2-2
     do j=10,n2+9
        do i=2, n2+1
           arr2(i,j,k) = dble(i*j*k)
        end do
     enddo
  end do

  do j=-2, n1-3
     do i=1, n1
        arr1(i,j) = dble(i*j)
     end do
  end do
  arr2(2:n2-1:2, 10, -1:n2-2:3 ) = arr1(:,:)   ! ERROR

  print *,'arr1',arr1(1,-2)
  deallocate(arr1,arr2)
end program test
