!***************************************************************************
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_D_3_a.f90
!
!     Summary:           non-conforming use of Fortran 90 arrays
!
!     Test description:  use array section to read or write between two arrays
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          non-conforming use of Fortran 90 arrays
!
!     Last modified:     06/06/05
!
!     Programmer:        Ying Xu
!*************************************************************************

program test
  implicit none
  integer :: n
  double precision, allocatable :: arr1(:), arr2(:)
  double precision :: pi
  integer :: i

  pi = 4.0*atan(1.0)
  n = int(sin(0.25*pi)*100)
  allocate(arr1(n),arr2(n+1))
  do i=1,n+1
     arr2(i) = dble(i)
  end do
  arr1 = sqrt(arr2)    !  ERROR
  print *,arr1, arr2
  deallocate(arr1,arr2)
end program test

