!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_2_1_b_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D statically allocated array 
!                        The lower bounds of the array are equal to 1 
!                        The array is derived data type.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rstack
  implicit none
  type S
     integer :: num
     character :: gender
  end type S
  integer, parameter :: N=20, M=10
  type(S), dimension(:,:) :: arr(1:N, 1:M)
  type(S) :: a
  integer :: i, j
! initialize the array
  do j=1, M
     do i=1, N
        arr(i,j)% num = i*j
        arr(i,j)% gender = 'f'
     enddo
  end do 
  a % num = arr(i-1,j+9) % num    ! Reading beyond the bound  ERROR
  a % gender = arr(i-1,1) % gender   
  print *,'a=',a
  stop
end program rstack
