!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_2_2_a_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D statically allocated array 
!                        The lower bounds of the array are equal to 1 
!                        The array is derived data type.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program wstack
  implicit none
  type S
     integer :: num
     character :: gender
  end type S
  integer, parameter :: N=20, M=10
  type(S), dimension(:,:) :: arr(1:N, 1:M)
  type(S) :: a
  integer :: i, j
  a % num = 10
  a % gender = 'm'
! initialize the array
  do j=1, M
     do i=1, N
        arr(i,j)% num = i*j
        arr(i,j)% gender = 'f'
     enddo
  end do 
  arr(i-1,j) % num = a % num   ! writing beyond the bound  ERROR
  arr(i-1,1) % gender = a % gender
  print *,'arr(1,1)%num=',arr(1,1)%num
  stop
end program wstack
