!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_2_2_d_r.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D statically allocated array 
!                        The lower bounds of the array are equal to 1 
!                        The array is real.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        real array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program wstack
  implicit none
  integer, parameter :: N=20, M=10
  real, dimension(:,:) :: arr(1:N, 1:M)
  real :: a
  integer :: i, j
  a = 30
! initialize the array
  do j=1, M
     do i=1, N
        arr(i,j) = i*j
     enddo
  end do 
  arr(i-1,j-m-10) = a ! writing Reading beyond the bound  ERROR
  print *,'arr(1,1)=',arr(1,1)
  stop
end program wstack
