!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_2_3_a_i.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D statically allocated array 
!                        The lower bounds of the array are equal to 1 
!                        The array is integer.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        integer array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rstack
  implicit none
  integer, parameter :: N=20, M=10
  integer, dimension(:,:) :: arr(1:N, 1:M)
  integer :: a
  integer :: i, j
! initialize the array
  do j=1, M
     do i=1, N
        arr(i,j) = i*j
     enddo
  end do 
  a = arr(i,j-1)    ! Reading beyond the bound ERROR 
  print *,'a =', a
  stop
end program rstack
