!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_3_3_d_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D statically allocated array
!                        The lower bounds of the array are not equal to 1 
!                        The array is derived data type.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program rstack
  implicit none
  type S
     integer :: num
     character :: gender
  end type S
  integer, parameter :: M1=-10, M2=10, N1=50, N2=100
  type(S) :: arr(M1:M2,N1:N2), a
  integer :: i, j
  do i=M1,M2
     do j=N1, N2
        arr(i,j)%num = i*(j-1)
        arr(i,j)%gender = 'f'
     end do
  end do 
  a%num = 1
  a % gender = 'm'
  i = i-(M2-M1)-20
  j = N1 + (N2-N1)/2     
  a = arr(I,j)       ! read out of bounds ERROR
  print *,'a=',a
  stop
end program rstack
