!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_5_1_d_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D statically allocated array
!                        through indirect indexing 
!                        The array is derived data type.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  implicit none
  type S
     integer :: num
     character :: gender
  end type S

  integer, parameter :: N=10
  integer :: indx(N),i
  type(S) :: arr(N), var                     ! DECLARE 

  do i=1,n
     indx(i) = mod(-200,i+101)
     arr(i)% num = indx(i)
     arr(i)%gender = 'f';
  end do
  print *,indx
  var%num = 0.d0
  do i=1,n
     var%num = var%num + arr(indx(i))%num  ! indx(1) = -98 ERROR
  enddo
  var%gender ='f'
  print *,'var ',var
end program test
