!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_1_5_2_a_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D statically allocated array
!                        through indirect indexing 
!                        The array is derived data type.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  implicit none
  type S
     integer :: num
     character :: gender
  end type S

  integer, parameter :: N=10
  integer :: indx(N),i
  type(S) :: arr(N), var              ! DECLARE 

  do i=1,n
     indx(i) = mod(I+55,N+3)
     arr(i)% num = indx(i)
     arr(i)%gender = 'f';
  end do
  print *,indx
  var%num = sum(indx)
  var%gender = 'm'
  do i=1,n
     arr(indx(i))%num  = var%num/(i+1)  ! store out of bounds indx(8) = n+1 ERROR
     arr(indx(i))%gender = var%gender
  end do

  print *,'var ',var
end program test
