!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_2_1_2_c_d.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated array
!                        The array is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
program wheap_1
  implicit none

  double precision, dimension(:), allocatable :: ptr
  double precision :: a
  integer :: i,istat
  
  a = 1.d0

  allocate(ptr(1:20), STAT= istat)
  if (istat == 0) then
     do i=1,20
        ptr(i) =  dble(i)
     end do
     ptr(i-21) = a  ! write out of bounds  ERROR
     print *,'i=',i,'ptr(1) = ',ptr(1) 
  end if
  deallocate(ptr,STAT=istat)
end program wheap_1
