!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_2_1_2_d_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated array
!                        The array is derived data type.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
program wheap
  implicit none
  type S
     integer :: num
     character :: gender
  end type S

  type(S), dimension(:), allocatable :: ptr
  type(S) :: a
  integer :: i,istat
  
  a%num = 1
  a%gender = 'f'

  allocate(ptr(1:20), STAT= istat)
  if (istat == 0) then
     do i=1,20
        ptr(i)%num = i
        ptr(i)%gender = 'f'
     end do
     ptr(i-50) = a  ! write out of bounds  ERROR
     print *,'ptr(1)=',ptr(1)
  end if
  deallocate(ptr,STAT=istat)
end program wheap
