!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_2_1_3_c_d.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated array
!                        The array is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rheap3
  implicit none

  double precision, dimension(:), allocatable :: ptr
  double precision :: a
  integer :: i,istat,n

  n=20 
  allocate(ptr(1:n), STAT= istat)
  if (istat == 0) then
     do i=1,n
        ptr(i) = dble(i) 
     end do
     a = 0.d0
     do i = 10,N+10
        a = a + ptr(i)  ! read out of bounds ERROR
     end do
     print *,'a=',a
 
  end if
  deallocate(ptr,STAT=istat)
end program rheap3
