!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_2_1_4_a_d.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated array
!                        The array is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
program rheap
  implicit none

  double precision, dimension(:), allocatable :: ptr
  double precision :: a
  integer :: i,istat,N

  n=20 
  a = 1.d0 
  allocate(ptr(1:n), STAT= istat)
  if (istat == 0) then
    do i=0,n-1
	ptr(i) = a   ! ERROR
	a = a+1.d0 
    enddo
    print *,'ptr(1) =',ptr(1)
  end if
  deallocate(ptr,STAT=istat)
end program rheap

