!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_2_1_5_d.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated array
!                        The array is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision data type 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
program rheap
  implicit none
  integer, parameter :: N=20
  double precision, allocatable, dimension(:) :: ptr
  integer :: indx, istat
  allocate(ptr(1:N), STAT= istat)
  if (istat == 0) then
     do indx=1, N
        ptr(indx) = dble(indx)
     end do

     do indx = 1, N
        ptr(indx) = ptr(indx+1) - 2*ptr(indx) + ptr(indx-1)  ! ERROR 
     end do
     print *,'ptr(1)=', ptr(1), ' ptr(n)=', ptr(N)
  end if
  deallocate(ptr, STAT=istat)
  stop
end program rheap
