!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_2_2_3_c_t.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of 2 D dynamically allocated array
!                        The array is derived data type.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
program rheap
  implicit none
  type S
     integer :: num
     character :: gender
  end type S
  integer, parameter :: N=20, M=10
  type(S), allocatable, dimension(:,:) :: ptr
  type(S) :: a
  integer :: i, j, istat
  allocate(ptr(N,M),STAT=istat)
  if (istat == 0) then
     do j=1, M
        do i=1, N
           ptr(i,j)%num = i*j
           ptr(i,j)%gender = 'f'
        enddo
     end do
     a = ptr(i-N-1,j-1)      ! read out of bounds ERROR 
     print *,'a=',a
     deallocate(ptr)
  end if
  stop
end program rheap
