!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_3_2_1_c_d.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of assumed-shape A(:,:)
!                        2 D array dummy argument in an external subroutine
!                        The array is double precision.
!
!     Support files:     F_F_3_2_1_c_d_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  interface 
    subroutine sub(arr,var,n,m)
       implicit none
       integer, intent(IN) :: n,m
       double precision, intent(INOUT) :: arr(:,:), var
    end subroutine sub
  end interface
  integer,parameter :: N=10, m=20
  double precision :: arr(n,m), var
  integer :: i,j,indx
  do j=1,m
     do i=1,n
        arr(i,j) = dble(i*j)
     end do
  end do
  var = 0.d0
  call sub(arr,var,n,m)
  print *,var, arr(1,1)
end program tests

