!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_F_6_1_2_c_d.f90
!
!     Summary:           Out of bounds indexing of arrays
!
!     Test description:  out-of-bounds indexing of assumed-size A(M1:M2,*)  
!                        2 D array dummy argument in an external function
!                        The array is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/24/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  interface
     double precision function sub(arr,n,m)
       implicit none
	  integer,intent(in) :: n,m
	  double precision, intent(inout):: arr(n,*)
     end function sub
  end interface
  integer,parameter :: N=10, m=20
  double precision :: arr(n,m), var
  integer :: i,j,indx
  do j=1,m
     do i=1,n
        arr(i,j) = dble(i*j)
     end do
  end do
  var = 0.d0
  var= sub(arr,n,m)
  print *,var, arr(1,1)
end program tests

double precision function sub(arr,n,m)
  implicit none
  integer,intent(in) :: n,m
  double precision, intent(inout):: arr(n,*) ! DECLARE

  integer :: I,J, bounds
  double precision :: tmp
  call random_number(tmp)
  if (sin(tmp*arr(1,1))>1.0) then
     j = 1
  else
     j = 0
  end if
  I = n/2
  arr(i,j) = arr(1,1)*2.0    ! read out of bound ERROR
  sub = sum(arr(:,1))
  print *,arr(1,1)
end function sub
