!***************************************************************************
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_K_2_3_a.f90
!
!     Summary:           out of bounds for FORALL 
!
!     Test description:  use the forall structure to loop over a 2d array
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds
!
!     Last modified:     06/10/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  integer :: i,j, M1,M2,N1,N2
  double precision, allocatable, dimension(:,:) :: arr,arr1
  double precision :: s
  
  M1=11
  M2=20
  N1=-1
  N2=N1+20-1
  allocate(arr(M1:M2, N1:N2),arr1(M1-1:M2-1,N1:N2))

  arr = 1.d0
  forall (i=M1:M2, j=N1:N2)
     arr(i,j) = 1.0/dble(i+j+20)
  end forall
  arr1 = 1.0
  forall (i=M1-1:M2-1, j=N1:N2)
     arr1(i,j) = arr1(i,j) + arr(i,j)**2   ! ERROR
  end forall
  print *,s  
  deallocate(arr,arr1)
end program tests
