!***************************************************************************
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_J_1_c.f90
!
!     Summary:           memory leak 
!
!     Test description:  reset the pointer to somewhere else or nullify it
!                        before deallocate the pointer
!
!     Support files:     not needed
!
!     Env. requirements: 
!
!     Keywords:          memory leak
!
!     Last modified:     06/09/2005
!
!     Programmer:        Ying Xu
!*************************************************************************

program test
  implicit none
  integer, parameter :: m=10
  double precision :: arr(m)
  call sub(arr,m)
  print *,arr
end program test
   
subroutine sub(arr,m)
   integer, intent(in) :: m
   double precision, intent(inout) :: arr(m)
   
   double precision, pointer, dimension(:) :: ptr1,ptr2   ! DECLARE
   integer :: n=20,count,i
   
   do count = 1, m
      allocate(ptr1(n))     
      ptr2 => ptr1
      do i=1,n
         ptr2(i) = dble( count + i)
      end do
      arr(count) = ptr1(n)
      nullify(ptr1)        ! ERROR   
   end do
   deallocate(ptr2)
 end subroutine sub
 
