!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_1_2_1_c_d.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated pointer 
!                        The array is double precision.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        double precision array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------
! *  Here we use double precision.

program rheap_1
  implicit none

  double precision, dimension(:), pointer :: ptr
  double precision :: a
  integer :: i,istat
  
  allocate(ptr(1:20), STAT= istat)
  if (istat == 0) then
     do i=1,20
        ptr(i) = dble(i) 
     end do
     a = ptr(i-21)   ! Reading beyond the allocated memory block  ERROR
     print *,'a=',a
  end if
  deallocate(ptr,STAT=istat)
end program rheap_1

