!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_1_2_1_d_i.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated pointer 
!                        The array is integer.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        integer array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rheap2
  implicit none

  integer, dimension(:), pointer :: ptr
  integer :: a
  integer :: i,istat
  
  allocate(ptr(1:20), STAT= istat)
  if (istat == 0) then
     do i=1,20
        ptr(i) = i 
     end do
!   now i=21
     a = ptr(i-32)  ! Reading beyond the allocated memory block ptr(-11)  ERROR
     print *,'a=',a
  end if
  deallocate(ptr,STAT=istat)
end program rheap2
