!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_1_2_3_a_r.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated pointer 
!                        The array is real.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        real array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rheap
  implicit none

  real, dimension(:), pointer :: ptr
  real :: a
  integer :: i,istat,N

  n=20 
  allocate(ptr(1:n), STAT= istat)
  if (istat == 0) then
    do i=1,n
	ptr(i) = dble(i)
    enddo
    do i=0,n-1
       a = ptr(i)    ! reading ptr beyond the bound 0 ~ N-1  ERROR
       print *,'a=',a
    end do
  end if
  deallocate(ptr,STAT=istat)
end program rheap

