!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_1_2_4_c_t.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 1 D dynamically allocated pointer 
!                        The array is derived data type.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        derived array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rheap2
  implicit none
  type S
     integer :: num
     character :: gender
  end type S
  
  type(S), dimension(:), pointer :: ptr
  integer :: a
  integer :: i,istat, n
  n=20 
  a = 1
  allocate(ptr(1:n), STAT= istat)
  if (istat == 0) then
     do i=10,n+10  
        ptr(i)%num = a       ! * write beyond bound -10~n ERROR
	a = a+i
     end do
     ptr(:)%gender = 'f'
!   now i=21
    print *,'ptr(1)=',ptr(1)%num, ptr(1)%gender
  end if
  deallocate(ptr,STAT=istat)
end program rheap2
