!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_G_2_3_b_i.f90
!
!     Summary:           Out of bounds indexing of pointer
!
!     Test description:  out-of-bounds indexing of 2 D statically allocated pointer 
!                        The lower bounds of the array are equal to 1 
!                        The array is integer.
!
!     Support files:     
!
!     Env. requirements: not needed
!
!     Keywords:          out-of-bounds indexing 
!                        integer array 
!
!     Last modified:     05/29/05
!
!     Programmer:        Ying Xu
!*************************************************************************
!---------------------------------------------------------------

program rheap
  implicit none
  integer, parameter :: N=20, M=10
  integer, allocatable, dimension(:,:) :: ptr
  integer :: a
  integer :: i, j, istat
! initialize the array
  allocate(ptr(N,M),STAT=istat)
  if (istat == 0) then
     do j=1, M
        do i=1, N
           ptr(i,j) = i*j
        enddo
     end do
     a = ptr(i+10,j-1)    ! Reading beyond the bound: arr(N+11,M), i=N+1, j=M+1  ERROR 
     print *,'a=',a
     deallocate(ptr)
  end if
  stop
end program rheap
