!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_E_2_1_2_a.f90
!
!     Summary:           string out-of-bounds 
!
!     Test description:  string out-of-bounds for 1D string array;
!                        character(*) A(N1:N2) as dummy argument 
!                        in an external subroutine; 
!                        write through array section 
!
!     Support files:     not needed 
!
!     Env. requirements: not needed
!
!     Keywords:          string out-of-bounds 
!                        in external subroutine 
!
!     Last modified:     05/20/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  integer, parameter :: strlen=20, n=10
  character(len=strlen) :: str(n), substr
  integer :: i, indx
  do i=1,n
     str(i) = '12345678901234567890'
  end do
  indx = n/2
  print * , str(indx)(:)
  call sub(str,substr,n)
  print *, str(n/2)(:)
end program tests

subroutine sub(str1, str2, n)
  integer, intent(in) :: n
  character (*), intent(inout) :: str1(n)  ! DECLARE
  character (*), intent(inout) :: str2
  integer :: I1, I2, indx
  indx = n/2
  I1 = 2
  I2 = len(str1(indx)(:)) + I1 - 1
  str2 = 'In the subroutine'
  str1(indx)(I1:I2) = str2        ! write out of bounds ERROR
  return
end subroutine sub
