!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_E_3_3_1_a.f90
!
!     Summary:           string out-of-bounds 
!
!     Test description:  string out-of-bounds for 1D string array
!                        character *(*) A as dummy argument
!                        in an internal subroutine; 
!                        the string on right hand side is declared in
!                        the main program; 
!                        read through array section 
!
!     Support files:     not needed 
!
!     Env. requirements: not needed
!
!     Keywords:          string out-of-bounds 
!                        in an internal subroutine 
!
!     Last modified:     07/25/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program tests
  implicit none
  integer, parameter :: strlen=20, n=10
  character(len=strlen) :: str(n), substr
  integer :: i, indx
  do i=1,n
     str(i) = 'This is a test strin'
  end do
  indx = n/2
  print * , str(indx)(:)
  call sub(substr)
  print *, substr

contains
  subroutine sub(str1)
    character (*), intent(inout) :: str1
    integer :: I1, I2, indx
    indx = n/2
    I1 = 2
    I2 = len(str(indx)(:)) + I1 - 1
    str1 = str(indx)(I1:I2)   ! read out of bounds ERROR
    return
  end subroutine sub
end program tests




