!*************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!*************************************************************************
!*************************************************************************
!
!     Name of the test:  F_C_1_1_a.f90
!
!     Summary:           incorrect argument data types and 
!                        incorrect number of arguments
!
!     Test description:  the argument number in called subroutine/function  
!                        is different from the calling statement
!                        
!     Support files:     F_C_1_1_a_s.f90
!
!     Env. requirements: Not needed
!
!     Keywords:          incorrect argument number
!                        external subroutine
!
!
!     Last modified:     5/3/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************

program tests
  implicit none
  double precision :: pi
  double precision, allocatable :: array(:)
  integer :: n,i,flag
  double precision :: var

  pi = 4.0*atan(1.0)
  flag = int(cos(pi))*(-1)
  n = sin(pi*0.1)*100
  allocate(array(N))
  do i=1,n
     array(i) = cos(dble(i)/dble(n)*pi)
  end do

  call sub1(array,n,flag,var)  ! CALLING ERROR
  
  print *, var, flag
  deallocate(array)
end program tests



