!*************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!*************************************************************************
!***************************************************************************
!
!     Name of the test:  F_C_2_2_a.f90
!
!     Summary:           incorrect argument data types and 
!                        incorrect number of arguments
!
!     Test description:  the argument data type in called 
!                        subroutine/function  
!                        is different from the calling statement
!                        called subroutine expected derived type(RECORD), 
!                        calling statement is complex
!                        
!     Support files:     F_C_2_2_a_s.f90
!                        F_C_2_2_a_s1.f90
!
!     Env. requirements: Not needed
!
!     Keywords:          incorrect argument data type
!                        external subroutine
!
!
!     Last modified:     5/3/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************

program tests
  implicit none
  double precision :: pi
  complex, allocatable :: array(:)
  complex :: theta
  integer :: n,i,flag
  double precision :: var

  pi = 4.0*atan(1.0)
  flag = int(cos(pi))*(-1)
  n = sin(pi*0.1)*100
  allocate(array(N))
  do i=1,n
     call random_number(var)
     theta = cmplx(0, 2.0*pi*var)
     array(i) = exp(theta)
  end do
  call sub1(array,n,flag,var)  ! CALLING ERROR
  
  print *, var, flag
  deallocate(array)
end program tests



