!*************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!*************************************************************************
!*************************************************************************
!
!     Name of the test:  F_C_3_1_a.f90
!
!     Summary:           incorrect argument data types and
!                        incorrect number of arguments
!
!     Test description:  the size of array in the argument number in 
!                        called subroutine/function 
!                        is larger than the calling statement
!
!     Support files:     F_C_3_1_a_s.f90
!
!     Env. requirements: Not needed
!
!     Keywords:          array size conflict
!                        external subroutine
!
!
!     Last modified:     5/3/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************
program tests
  implicit none
  double precision :: pi
  double precision, allocatable :: array(:,:)
  integer :: n,i,flag,j
  double precision :: var

  pi = 4.0*atan(1.0)
  flag = int(cos(pi))*(-1)
  n = 100
  allocate(array(int(N/4),2))
  do j=1,2
     do i=1,n/4
        array(i,j) = cos(dble(i)/dble(n)*pi)
     end do
  end do

  call sub1(array,n,flag,var)  ! CALLING ERROR

  print *, var, flag
  deallocate(array)
end program tests



         
