!*************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!*************************************************************************
!*************************************************************************
!
!     Name of the test:  F_C_4_2_a.f90
!
!     Summary:           incorrect argument data types and
!                        incorrect number of arguments
!
!     Test description:  dummy argument is an array
!                        while actual argument is a scalar
!
!     Support files:     F_C_4_2_a_s.f90
!
!     Env. requirements: Not needed
!
!     Keywords:          array dimension conflict
!                        external subroutine
!
!
!     Last modified:     5/3/2005
!
!     Programmer:        Ying Xu, Iowa State Univ.
!*************************************************************************
program tests
  implicit none
  double precision :: pi
  integer :: n,i,flag,j
  double precision :: var,expr
  double precision, allocatable :: array(:)
  double precision :: fct1

  pi = 4.0*atan(1.0)
  flag = int(cos(pi))*(-1)
  n = 100
  allocate(array(N))

  do i=1,n
     array(i) = cos(dble(i)/dble(n)*pi)
  end do

  expr = sin(pi/3.0)
  var = cos(pi/3.0)
  array(1) = maxval(array(1:n))+ fct1(n,flag,var,expr)  ! CALLING ERROR

  print *, var, expr, array(1)
  deallocate(array)
end program tests
