!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_a_d.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is declared the main program
!                        The array is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        in internal subroutine 
!                        double precision data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer, parameter :: N=10
  double precision :: pi
  double precision :: arr(N)
  double precision :: arr1(N)   ! DECLARE
  double precision :: a
  integer :: i, flag

  pi = 4.0*atan(1.d0)
  flag = sin(2.d0*pi)
  do i=1,N
     arr(i) = dble(i)
  end do
  call sub1(a)
  print *,a+arr(1)

  contains
    subroutine sub1(a)
      double precision, intent(inout):: a
            integer :: i
      if (flag == 1) then
        print *,'flag =',flag, ' initialize arr in sub1'
        do i=1,N
           arr1(i) = dble(i)
        enddo
      endif

      do i=1,1
         arr1(i) = arr1(i) ** 2.0  ! read uninitialized array element. ERROR
      enddo
      i = min(N,min(N/2,1))
      a = arr1(i)   
    end subroutine sub1
  end program main
      

