!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_a_z.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is declared in an internal subroutine; 
!                        The array is complex.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        in internal subroutine 
!                        complex data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer, parameter :: N=10
  double precision :: pi
  complex :: arr(N)
  complex :: a
  complex :: arr1(N)     ! DECLARE
  integer :: i, flag

  pi = 4.0*atan(1.d0)
  flag = sin(2.d0*pi)
  do i=1,N
     arr(i) = cmplx(real(i)/real(n), log(real(i)))
  end do
  call sub1(a)
  print *,'a',a,' arr(N/2)',arr(N/2)

  contains
    subroutine sub1(a)
      complex, intent(inout):: a
      integer :: i
      if (flag == 1) then
        print *,'flag =',flag, ' initialize arr in sub1'
        do i=1,N
           arr1(i) =  cmplx(real(i)**2/real(n), log(real(i)))
        enddo
      endif

      do i=1,1
         arr1(i) = arr1(i) ** 2.0   ! read uninitialized array element. ERROR
      enddo
      a = arr1(1)
    end subroutine sub1
  end program main
      

