!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_b_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is declared in an internal function; 
!                        The array is derived data type.
!
!     Support files:     F_A_1_1_b_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        in internal function 
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  integer, parameter :: N=10
  double precision :: pi
  type(record) :: arr(N)
  type(record) :: a
  type(record) :: arr1(N), tmp         ! DECLARE
  integer :: i, flag

  pi = 4.0 * atan(1.d0)
  flag = sin(2.d0*pi)

  do i=1,N
     arr(i)%age = n-i
     arr(i)%gender = 'm'
  end do
  a= fct1()
  print *,'a',a,'  arr(1)',arr(1)
  
contains
  type(record) function fct1()
    integer :: i

    if (flag == 1) then
      print *,'flag=',flag,' initialize arr in fct1'
      do i=1,n
         arr1(i)%age = i
         arr1(i)%gender = 'f'
      enddo
    endif

    tmp%age = arr1(1)%age+10    ! read uninitialized array element. ERROR
    tmp%gender = 'f'

    fct1 = tmp
    return
  end function fct1
end program main

