!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_b_y.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is declared in an internal function; 
!                        The array is complex.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        in internal function 
!                        complex data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer, parameter :: N=10
  double precision :: pi
  complex (kind=kind(1.d0)) :: arr(N)
  complex (kind=kind(1.d0)) :: a
  complex (kind=kind(1.d0)) :: arr1(N)   ! DECLARE
  integer :: i, flag

  pi = 4.0 * atan(1.d0)
  flag = sin(2.d0*pi)

  do i=1,N
     arr(i) = cmplx(dble(i)/dble(n), log(dble(i)))
  end do
  a= fct1() + arr(1)
  print *,'a',a,'arr(1)',arr(1)

contains
  complex (kind=kind(1.d0)) function fct1()
    integer :: i

    if (flag == 1) then
      print *,'flag=',flag,' initialize arr in fct1'
      do i=1,n
         arr1(i) =  cmplx(dble(i)/dble(n), log(dble(i)))
      enddo
    endif

    do i=1,1
       arr1(i) = arr1(i)**2  ! read uninitialized array element. ERROR
    enddo
    fct1 = arr1(1)
    return
  end function fct1
end program main

