!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_c_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is declared in an external subroutine; 
!                        The array is derived data type.
!
!     Support files:     F_A_1_1_c_t_s.f90 
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        in external subroutine 
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  integer, parameter :: N=10
  type(record) :: arr(N)
  type(record) :: a
  double precision :: pi
  integer :: i, flag

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))

  do i=1,N
     arr(i)%age = n-i
     arr(i)%gender = 'm'
  end do
  call sub1(a,N,flag)
  print *,'a',a,'arr(1)',arr(1)

end program main

subroutine sub1(a,N,flag)
  use F_A_test_para 
  integer, intent(in) :: N,flag
  type(record), intent(out):: a
  type(record) :: arr(N)          ! DECLARE
  integer :: i
  if (flag == 1 ) then
     do i=1,n
        arr(i)%age = i
        arr(i)%gender = 'f'
     enddo
  endif
  a%age = arr(1)%age    ! read uninitialized array element. ERROR
  a%gender = 'f'
end subroutine sub1

      
