!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_c_y.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is declared in an external subroutine; 
!                        The array is complex.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        in external subroutine 
!                        complex data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer, parameter :: N=10
  complex (kind=kind(1.d0)) :: arr(N)
  complex (kind=kind(1.d0)) :: a
  double precision :: pi
  integer :: i, flag

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))

  do i=1,N
     arr(i) =  cmplx(dble(i)/dble(n), log(dble(i)))
  end do
  call sub1(a,n,flag)
  print *,'a',a,'arr(1)',arr(1)

end program main

subroutine sub1(a,N,flag)
  integer, intent(in) :: N,flag
  complex (kind=kind(1.d0)), intent(out):: a
  complex (kind=kind(1.d0)) :: arr(N)    ! DECLARE
  integer :: i
  if (flag == 1 ) then
     do i=1,n
        arr(i) =  cmplx(dble(i)**2/dble(n), log(dble(i)))
     enddo
  endif
  do i=1,1
     arr(i) = arr(i)**2  ! read uninitialized array element. ERROR
  enddo
  a = arr(1)
end subroutine sub1

      
