!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_d_r.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is declared in an external function; 
!                        The array is real.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        in external function 
!                        real data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer, parameter :: N=10
  real :: arr(N)
  real :: a, fct1
  double precision :: pi
  integer :: i, flag

  pi = atan(1.0)*4.0 
  flag = int(sin(2.0*pi))
  
  do i=1,N
     arr(i) = dble(i)
  end do

  a = fct1(N, flag)
  print *,'a',a,'arr(1)',arr(1)
end program main

real function fct1(N, flag)
  implicit none
  integer, intent(in) :: N, flag
  double precision :: pi  
  real ::  arr(N)      ! DECLARE
  integer :: i

  if ( flag == 1) then
     do i=1,n
       arr(i) = dble(i)
     enddo
  endif
 
  do i=1,1
     arr(i) = arr(i)**2    ! read from an uninitialized array. ERROR
  enddo
  i = min(N,min(N/2,1))
  fct1 = arr(i) 
  return
end function fct1


