!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_e_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is passed to an external 
!                        subroutine as a dummy argument; 
!                        The array is derived data type.
!
!     Support files:     F_A_1_1_e_t_s.f90 
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        dummy argument in external subroutine
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  use F_A_test_para 
  implicit none
  integer, parameter :: N=10
  type(record) :: arr(N)
  type(record) :: a
  double precision :: pi
  integer :: flag
  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))

  call sub1(arr,n,a,flag)
  
  print *,'a=',a
end program unitia

subroutine sub1(array,n,a, flag)
  use F_A_test_para
  integer :: N
  type(record), intent(inout) :: array(N)     ! DECLARE 
  type(record), intent(out) :: a
  integer, intent(in) :: flag
  integer :: i
  type(record) :: tmp

  if ( flag == 1) then
      do i=1,n
         array(i)%age = i
         array(i)%gender = 'f'
      enddo
  endif      
  tmp%age = array(1)%age    ! read uninitialized array element. ERROR
  tmp%gender = 'f'
  a = tmp
end subroutine sub1
  
