!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_e_y.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is passed to an external 
!                        subroutine as a dummy argument; 
!                        The array is complex.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        dummy argument in external subroutine
!                        complex data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  integer, parameter :: N=10
  complex (kind=kind(1.d0)) :: arr(N)
  complex (kind=kind(1.d0)) :: a
  double precision :: pi
  integer :: flag
  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))

  call sub1(arr,n,a,flag)
  
  print *,'a=',a
end program unitia

subroutine sub1(array,n,a, flag)
  integer :: N
  complex (kind=kind(1.d0)), intent(inout) :: array(N)  ! DECLARE
  complex (kind=kind(1.d0)), intent(out) :: a
  integer, intent(in) :: flag
  integer :: i

  if ( flag == 1) then
      do i=1,n
          array(i) =  cmplx(dble(i)/dble(n), log(dble(i)))
      enddo
  endif      
  
  do i=1,1
     array(i) = array(I)**2   ! read uninitialized array element. ERROR
  enddo
  a = array(1)
end subroutine sub1
  
