!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_f_i.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is passed to an external
!                        function as a dummy argument; 
!                        The array is integer.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        dummy argument in external function
!                        integer data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  integer, parameter :: N=10
  integer :: arr(N)
  integer :: a,fct1
  double precision :: pi
  integer :: i, flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))

  a = fct1(arr,n,flag)
  print *,'a=',a
end program unitia

integer function fct1(array,n,flag)
  integer, intent(in) :: N,flag
  integer, intent(inout) :: array(N)  ! DECLARE
  integer :: i

  if ( flag == 1) then
      do i=1,n
          array(i) = i*(i-1)
      enddo
  endif      

  do i=1,1
     array(i) = array(I)**2  ! read uninitialized array element. ERROR
  enddo
  
  fct1 = array(i-1)
  return 
end function fct1
  
