!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_f_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is passed to an external
!                        function as a dummy argument; 
!                        The array is derived data type.
!
!     Support files:     F_A_1_1_f_t_s.f90 
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        dummy argument in external function
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  use F_A_test_para 
  implicit none
  integer, parameter :: N=10
  type(record) :: arr(N)
  type(record) :: a,fct1
  double precision :: pi
  integer :: i, flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))

  a = fct1(arr,n,flag)
  print *,'a=',a
end program unitia
function fct1(array,n,flag)
  use F_A_test_para 
  integer, intent(in) :: N,flag
  type(record) :: fct1
  type(record), intent(inout) :: array(N)    ! DECLARE 
  type(record) :: tmp
  integer :: i

  if ( flag == 1) then
      do i=1,n
          array(i)%age = i
          array(i)%gender = 'f'
      enddo
  endif      

  tmp%age = array(1)%age    ! read uninitialized array element. ERROR
  tmp%gender = 'f'
  fct1 = tmp
  return 
end function fct1
  
