!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_a_c.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is declared in an internal subroutine; 
!                        The array is character.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        in internal subroutine 
!                        character type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  character, allocatable, dimension(:) :: arr
  character, allocatable, dimension(:) :: arr1  ! DECLARE
  character :: var
  double precision :: pi
  integer :: N,istat,i, flag, base
  
  pi = 4.d0*atan(1.0)
  flag = int(sin(2.0*pi)) 
  N = 10
  base = iachar('a')
  allocate(arr(N),STAT=istat)
  if( istat==0) then
     do i=1,N
        arr(i) = achar(base + i)
     end do
     call sub1(var)
     print *,' var=',var,'  arr(N)',arr(N)
  end if
  deallocate(arr)
  contains
    subroutine sub1(var)
      character, intent(out) :: var
      integer :: i

      allocate(arr1(N))  
      if ( flag==1) then
         do i=1,n
           arr1(i) = achar(base + i)
         enddo
      endif
      i=1
      var = achar(iachar(arr1(i))+1) ! read uninitialized array element. ERROR
      deallocate(arr1)
      return
    end subroutine sub1
end program unitia
