!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_b_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is declared in an internal function; 
!                        The array is derived data type.
!
!     Support files:     F_A_2_1_b_t_s.f90 
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        in internal function 
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  use F_A_test_para 
  implicit none
  type(record), allocatable, dimension(:) :: arr
  type(record), allocatable, dimension(:) :: arr1 ! DECLARE
  type(record) :: var
  double precision :: pi
  integer :: N,istat,i,flag

  pi = 4.0*atan(1.0)
  flag = sin(2.0*pi)   
  N = 10
  allocate(arr(N),STAT=istat)
  if( istat==0) then
     do i=1,N
        arr(i)%age = n-i
        arr(i)%gender = 'm'
     end do
     var =  fct1()
     print *,' var=',var,'  arr(N)',arr(N)
  end if
  deallocate(arr)

  contains
    type(record) function fct1()
      integer :: i
      type(record) :: tmp

      allocate(arr1(N))      
      if (flag==1) then
         do i=1,n
            arr1(i)%age = i
            arr1(i)%gender = 'f'
         enddo
      endif
      tmp%age = arr1(1)%age    ! read uninitialized array element. ERROR
      tmp%gender = 'f'
      fct1 = tmp
      deallocate(arr1)
      return
    end function fct1
end program unitia
