!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_b_z.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is declared in an internal function; 
!                        The array is complex.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        in internal function 
!                        complex data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  complex, allocatable, dimension(:) :: arr
  complex, allocatable, dimension(:) :: arr1   ! DECLARE 
  complex :: var
  double precision :: pi
  integer :: N,istat,i,flag

  pi = 4.0*atan(1.0)
  flag = sin(2.0*pi)   
  N = 10
  allocate(arr(N),STAT=istat)
  if( istat==0) then
     do i=1,N
        arr(i) = cmplx(real(i)/real(n),log(real(i)))
     end do
     var =  fct1()
     print *,' var=',var,'  arr(N)',arr(N)
  end if
  deallocate(arr)

  contains
    complex function fct1()
      integer :: i
      allocate(arr1(N))      
      if (flag==1) then
         do i=1,n
            arr1(i) = cmplx(real(i)**2/real(n),log(real(i)))
         enddo
      endif

      do i=1,1
         arr1(i) = arr1(i)**2  ! read uninitialized array element. ERROR
      enddo
      i = min(N,min(N/2,1))
      fct1 = arr1(i)   
      deallocate(arr1)
      return
    end function fct1
end program unitia
