!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_c_z.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is declared in an external subroutine; 
!                        The array is complex.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        in external subroutine 
!                        complex data type 

!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  complex, allocatable, dimension(:) :: arr
  complex :: var
  integer :: N,istat,i, flag
  double precision :: pi
  
  pi = 4.0*atan(1.0)
  flag = int(sin(2.0*pi))
  N = 20

  allocate(arr(N),STAT=istat)
  if( istat==0) then
     do i=1,N
        arr(i) = cmplx(real(i)/real(n),log(real(i)))
     end do
     call sub1(var,flag)
     print *,' var=',var,'  arr(N)',arr(N)
  end if
  deallocate(arr)
end program unitia

subroutine sub1(var,flag)
  implicit none
  complex, intent(out) :: var
  integer, intent(in) :: flag
  complex, allocatable, dimension(:) :: array ! DECLARE 
  integer :: i,N, istat
  n=20
  allocate(array(N),STAT = istat)  
  if (istat == 0)then
     if (flag == 1) then
        do i=1,n
           array(i) = cmplx(real(i)**2/real(n),log(real(i)))
        enddo
     endif
     do i=1,1
        array(i) = array(i)**2 ! read uninitialized array element. ERROR
     enddo
     var = array(1)
  else
     var = 0.d0
  end if
  deallocate(array)
  return
end subroutine sub1


