!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_d_c.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is declared in an external function; 
!                        The array is character.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        in external function 
!                        character type 

!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  character, allocatable, dimension(:) :: arr
  character :: var, fct1
  double precision :: pi
  integer :: N,istat,i, flag, base

  pi = 4.0*atan(1.0)
  flag = int(sin(2.0*pi))
  N = 20
  base = iachar('a')
  allocate(arr(N),STAT=istat)
  if( istat==0) then
     do i=1,N
        arr(i) = achar(base + i)
     end do

     var = fct1(flag)
     print *,' var=',var,'  arr(N)',arr(N)
  end if
  deallocate(arr)
end program unitia

character function fct1(flag)
  implicit none
  integer, intent(in) :: flag
  character, allocatable, dimension(:) :: array   ! DECLARE
  integer :: i,N, istat, base
  character :: pi

  N=10
  base = iachar('c')
  allocate(array(N),STAT = istat)
  if (istat == 0) then
     if (flag == 1) then
        do i=1,n
           array(i) = achar(base + n-i)
        enddo
     endif
     i = min(N,min(N/2,1))
     fct1 = achar(iachar(array(i))+1) ! read uninitialized array element. ERROR
  else
     fct1 = 'a'
  end if
  deallocate(array)
  return
end function fct1
