!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_d_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is declared in an external function; 
!                        The array is derived data type.
!
!     Support files:     F_A_2_1_d_t_s.f90 
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        in external function 
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  use F_A_test_para 
  implicit none
  type(record), allocatable, dimension(:) :: arr
  type(record) :: var, fct1
  double precision :: pi
  integer :: N,istat,i, flag

  pi = 4.0*atan(1.0)
  flag = int(sin(2.0*pi))
  N = 20
  allocate(arr(N),STAT=istat)
  if( istat==0) then
     do i=1,N
        arr(i)%age = n-i
        arr(i)%gender = 'm'
     end do

     var = fct1(flag)
     print *,' var=',var,'  arr(N)',arr(N)
  end if
  deallocate(arr)
end program unitia
function fct1(flag)
  use F_A_test_para 
  implicit none
  integer, intent(in) :: flag
  type(record) :: fct1
  type(record), allocatable, dimension(:) :: array  ! DECLARE
  integer :: i,N, istat
  type(record) :: tmp
  double precision :: pi

  N=10
  allocate(array(N),STAT = istat)
  if (istat == 0) then
     if (flag == 1) then
        do i=1,n
           array(i)%age = i
           array(i)%gender = 'f'
        enddo
     endif
     tmp%age = array(1)%age    ! read uninitialized array element. ERROR
     tmp%gender = 'f'
     fct1 = tmp 
  else
     fct1%age = 10
     fct1%gender = 'm'
  end if
  deallocate(array)
  return
end function fct1
