!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_e_c.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is passed to an external 
!                        subroutine as a dummy argument; 
!                        The array is character.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        dummy argument in external subroutine
!                        character type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  character, allocatable, dimension(:) :: arr
  character :: var
  double precision :: pi
  integer :: N,istat,i,flag, base
  
  pi = 4.0*atan(1.0)
  flag = int(sin(2.0*pi))
  N = 10
  base = iachar('a')
  allocate(arr(N),STAT=istat)
  if( istat==0) then
     call sub1(arr,N,var,flag)
     print *,' var=',var,'  arr(N)',arr(N)
  end if
  deallocate(arr)
end program unitia

subroutine sub1(array,N,var,flag)
  implicit none
  integer, intent(in) :: flag, N
  character, intent(out) :: var
  character, intent(inout) :: array(N)   ! DECLARE

  integer :: i, base
  base = iachar('c')
  if (flag == 1) then
      do i=1,n
         array(i) = achar(base + n-i)
      enddo
  endif

  i = min(N,min(N/2,1))
  var =  achar(iachar(array(i))+1) ! read uninitialized array element. ERROR
  return
end subroutine sub1
