!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_e_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is passed to an external 
!                        subroutine as a dummy argument; 
!                        The array is derived data type.
!
!     Support files:     F_A_2_1_e_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        dummy argument in external subroutine
!                        derived data type
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  use F_A_test_para 
  implicit none
  type(record), allocatable, dimension(:) :: arr
  type(record) :: var
  double precision :: pi
  integer :: N,istat,i,flag
  
  pi = 4.0*atan(1.0)
  flag = int(sin(2.0*pi))
  N = 10
  allocate(arr(N),STAT=istat)
  if( istat==0) then
     call sub1(arr,N,var,flag)
     print *,' var=',var
  end if
  deallocate(arr)
end program unitia

subroutine sub1(array,N,var,flag)
  use F_A_test_para 
  implicit none
  integer, intent(in) :: flag, N
  type(record), intent(out) :: var
  type(record), intent(inout) :: array(N)    ! DECLARE
  type(record) :: tmp
  integer :: i
  if (flag == 1) then
      do i=1,n
         array(i)%age = n-i
         array(i)%gender = 'm'
      enddo
  endif
  tmp%age = array(1)%age    ! read uninitialized array element. ERROR
  tmp%gender = 'f'
  var = tmp   
  return
end subroutine sub1
