!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_f_r.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is passed to an external
!                        function as a dummy argument; 
!                        The array is real.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        dummy argument in external function
!                        real data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  real, allocatable, dimension(:) :: arr
  real :: var, fct1
  integer :: N,istat,i,flag
  double precision :: pi

  pi = 4.0*atan(1.0)
  flag = int(sin(2.0*pi))

  N = 10
  allocate(arr(N),STAT=istat)
  if( istat==0) then
     var = fct1(arr,N,flag)
     print *,' var=',var,'  arr(N)',arr(N)
  end if
  deallocate(arr)
end program unitia

real function fct1(array,N,flag)
  implicit none
  integer, intent(in) :: N,flag
  real, intent(inout) :: array(N)  ! DECLARE
  integer :: i 

  if (flag == 1) then
     do i=1,n
        array(i) = dble(i)
     enddo
  endif

  do i=1,1
     array(i) = array(i)**2    ! read uninitialized array element. ERROR
  enddo
  i = min(N,min(N/2,1))
  fct1 = array(i)  
  return
end function fct1
