!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_f_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is passed to an external
!                        function as a dummy argument; 
!                        The array is derived data type.
!
!     Support files:     F_A_2_1_f_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        dummy argument in external function
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  use F_A_test_para 
  implicit none
  type(record), allocatable, dimension(:) :: arr
  type(record) :: var, fct1
  integer :: N,istat,i,flag
  double precision :: pi

  pi = 4.0*atan(1.0)
  flag = int(sin(2.0*pi))

  N = 10
  allocate(arr(N),STAT=istat)
  if( istat==0) then
     var = fct1(arr,N,flag)
     print *,' var=',var
  end if
  deallocate(arr)
end program unitia
function fct1(array,N,flag)
  use F_A_test_para 
  implicit none
  integer, intent(in) :: N,flag
  type(record) :: fct1
  type(record), intent(inout) :: array(N)  ! DECLARE
  integer :: i
   type(record) :: tmp
  if (flag == 1) then
     do i=1,n
        array(i)%age = i
        array(i)%gender = 'f'
     enddo
  endif

  tmp%age = array(1)%age+10    ! read uninitialized array element. ERROR
  tmp%gender = 'f'

  fct1 = tmp
  return
end function fct1
