!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_h_y.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array declared in a module function; 
!                        The array is complex.
!
!     Support files:     F_A_2_1_h_y_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        in module function 
!                        complex data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  use F_A_2_1_h_s_y
  implicit none
  double precision :: pi
  complex (kind=kind(1.d0)) :: ans
  integer :: i, N,istat
  complex (kind=kind(1.d0)), allocatable :: arr(:)
  
  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))

  N = 100
  allocate(arr(N),STAT=istat)
  if (istat == 0) then
     do i=1,N
        arr(i) = cmplx(dble(i)/dble(n),log(dble(i)))
     end do
     ans = fct1(N,flag)
     print *,'ans = ',ans,' arr(n) =',arr(n)
  end if
  deallocate(arr)
end program test
     
