!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_i_i.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is passed to a 
!                        module subroutine as a dummy argument; 
!                        The array is integer.
!
!     Support files:     F_A_2_1_i_i_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        dummy argument in a module subroutine 
!                        integer data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  use F_A_2_1_i_s_i
  implicit none
  double precision :: pi
  integer :: ans
  integer :: i, N,istat
  integer, allocatable :: arr(:)
  
  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))

  N = 100
  allocate(arr(N),STAT=istat)
  if (istat == 0) then
     ans = 0.d0
     call sub1(arr,N,flag,ans)
     print *,'ans = ',ans,' arr(n) =',arr(n)
  end if
  deallocate(arr)
end program test
