!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_1_j_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated array
!                        uninitialized array is passed to 
!                        module function as a dummy argument; 
!                        The array is derived data type.
!
!     Support files:     F_A_2_1_j_t_s.f90
!
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated array 
!                        dummy argument in a module function 
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  use F_A_2_1_j_s_t
  use F_A_test_para 
  implicit none
  double precision :: pi
  type(record) :: ans
  integer :: i, N,istat
  type(record), allocatable :: arr(:)
  
  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))

  N = 100
  allocate(arr(N),STAT=istat)
  if (istat == 0) then
     ans = fct1(arr,N,flag)
     print *,'ans = ',ans
  end if
  deallocate(arr)
end program test
