!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_a_i.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array is declared in an internal subroutine; 
!                        The array is integer.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        in internal subroutine 
!                        integer data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  integer, pointer, dimension(:) :: ptr
  integer, pointer, dimension(:) :: ptrloc   ! DECLARE
  integer :: var
  integer :: N,istat,i,flag
  double precision :: pi

  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))
  N = 10
  allocate(ptr(N),STAT=istat)
  if( istat==0 ) then
     do i=1,N
        ptr(i) = mod(n,i)
     end do
     call sub1(var)
     print *,' var ',var,'  arr(N)',ptr(N)
  end if
  deallocate(ptr)
  contains
    subroutine sub1(var)
      integer, intent(out) :: var
      integer :: i
      allocate(ptrloc(N))
      if (flag ==1) then
         do i=1,n
            ptrloc(i) = i*(i-1)
         end do
      end if
      do i=1,1
         ptrloc(i) = ptrloc(i)**2   ! read uninitialized array element. ERROR
      end do
      var = ptrloc(i-1)    
      deallocate(ptrloc)
      return
    end subroutine sub1
end program unitia
