!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_a_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array is declared in an internal subroutine; 
!                        The array is derived data type.
!
!     Support files:     F_A_2_2_a_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        in internal subroutine 
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  use F_A_test_para 
  implicit none
  type(record), pointer, dimension(:) :: ptr
  type(record), pointer, dimension(:) :: ptrloc  ! DECLARE
  type(record) :: var
  integer :: N,istat,i,flag
  double precision :: pi

  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))
  N = 10
  allocate(ptr(N),STAT=istat)
  if( istat==0 ) then
     do i=1,N
        ptr(i)%age = i
        ptr(i)%gender = 'm'
     end do
     call sub1(var)
     print *,' var ',var,'  arr(N)',ptr(N)
  end if
  deallocate(ptr)
  contains
    subroutine sub1(var)
      type(record), intent(out) :: var
      integer :: i

      allocate(ptrloc(N))
      if (flag ==1) then
         do i=1,n
            ptrloc(i)%age = n-i
            ptrloc(i)%gender = 'f'
         end do
      end if
      var%age = ptrloc(1)%age   ! read uninitialized array element. ERROR
      var%gender = 'f'
      deallocate(ptrloc)
      return
    end subroutine sub1
end program unitia
