!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_b_d.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array is declared in an internal function; 
!                        The array is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        in internal function 
!                        double precision data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  double precision, pointer, dimension(:) :: ptr
  double precision, pointer, dimension(:) :: ptrloc  ! DECLARE
  double precision :: var
  double precision :: pi
  integer :: N,istat,i, flag

  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))
  N = 10
  allocate(ptr(N),STAT=istat)
  if( istat==0) then
     do i=1,N
        ptr(i) = dble(i)
     end do
     var = fct1()
     print *,' var ',var,'  arr(N)',ptr(N)
  end if
  deallocate(ptr)

  contains
    double precision function fct1()
      integer :: i

      allocate(ptrloc(N))
      if (flag ==1) then
         do i=1,n
            ptrloc(i) = dble(i)
         end do
      end if
      do i=1,1
         ptrloc(i) = ptrloc(i)**2    ! read uninitialized array element. ERROR
      end do
      i = min(N,min(N/2,1))
      fct1 = ptrloc(i)         
      deallocate(ptrloc)   

      return
    end function fct1
end program unitia
