!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_d_c.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array is declared in an external function; 
!                        The array is character.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        in external function 
!                        character type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none 
  character, pointer, dimension(:) :: ptr
  character :: var, fct1
  double precision :: pi
  integer :: N,istat,i,flag, base

  N = 10
  base = iachar('1')
  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))
  allocate(ptr(N),STAT=istat)
  if( istat==0 ) then
     do i=1,N
        ptr(i) = achar(base+n-i)
     end do
     var = fct1(flag)
     print *,' var ',var,'  arr(N)',ptr(N/2)
  end if
  deallocate(ptr)
end program unitia

character function fct1(flag)
  implicit none
  integer, intent(in) :: flag
  character,pointer, dimension(:) :: ptr   ! DECLARE
  integer :: i,N,istat, base

  N = 20
  base = iachar('1')
  allocate(ptr(N),STAT=istat)
  if (istat==0) then
     if (flag ==1) then
        do i=1,n
           ptr(i) = achar(base+n-i)
        end do
     end if
     i = min(n, min(n/2,1))
     fct1 =  achar(iachar(ptr(i))+1)    ! read uninitialized array element. ERROR
  end if
  deallocate(ptr)
  return
end function fct1
