!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_d_r.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array is declared in an external function; 
!                        The array is real.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        in external function 
!                        real data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none 
  real, pointer, dimension(:) :: ptr
  real :: var, fct1
  double precision :: pi
  integer :: N,istat,i,flag

  N = 10
  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))
  allocate(ptr(N),STAT=istat)
  if( istat==0 ) then
     do i=1,N
        ptr(i) = dble(i)
     end do
     var = fct1(flag)
     print *,' var ',var,'  arr(N)',ptr(N/2)
  end if
  deallocate(ptr)
end program unitia

real function fct1(flag)
  implicit none
  integer, intent(in) :: flag
  real,pointer, dimension(:) :: ptr  ! DECLARE
  integer :: i,N,istat
  double precision :: pi

  N = 20
  allocate(ptr(N),STAT=istat)
  if (istat==0) then
     if (flag ==1) then
        do i=1,n
           ptr(i) = dble(i)
        end do
     end if
     do i=1,1
        ptr(i) = ptr(i)**2   ! read uninitialized array element. ERROR
     end do
     i = min(n, min(n/2,1))
     fct1 = ptr(i)   
  end if
  deallocate(ptr)
  return
end function fct1
