!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_d_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array is declared in an external function; 
!                        The array is derived data type.
!
!     Support files:     F_A_2_2_d_t.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        in external function 
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  use F_A_test_para 
  implicit none 
  type(record), pointer, dimension(:) :: ptr
  type(record) :: var, fct1
  double precision :: pi
  integer :: N,istat,i,flag

  N = 10
  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))
  allocate(ptr(N),STAT=istat)
  if( istat==0 ) then
     do i=1,N
        ptr(i)%age = i
        ptr(i)%gender = 'm'
     end do
     var = fct1(flag)
     print *,' var ',var,'  arr(N)',ptr(N/2)
  end if
  deallocate(ptr)
end program unitia
function fct1(flag)
  use F_A_test_para 
  implicit none
  integer, intent(in) :: flag
  type(record) :: fct1
  type(record),pointer, dimension(:) :: ptr  ! DECLARE
  integer :: i,N,istat
   type(record) :: tmp
  double precision :: pi

  N = 20
  allocate(ptr(N),STAT=istat)
  if (istat==0) then
     if (flag ==1) then
        do i=1,n
           ptr(i)%age = n-i
           ptr(i)%gender = 'f'
        end do
     end if
     tmp%age = ptr(1)%age   ! read uninitialized array element. ERROR
     tmp%gender = 'f'
     fct1 = tmp
  end if
  deallocate(ptr)
  return
end function fct1
