!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_e_d.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array is passed to an external 
!                        subroutine as a dummy argument; 
!                        The array is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        dummy argument in external subroutine
!                        double precision data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  double precision, pointer, dimension(:) :: ptr
  double precision :: var
  integer :: N,istat,i, flag
  double precision :: pi
 
  N = 10
  allocate(ptr(N),STAT=istat)
  if( istat==0) then
     pi = 4.d0 * atan(1.0)
     flag = int(sin(2.d0*pi))
     call sub1(ptr,N,var,flag)
     print *,' var ',var,'  arr(N)',ptr(N/2)
  end if
  deallocate(ptr)
end program unitia

subroutine sub1(array,N,var,flag)
  implicit none
  integer, intent(in) :: N,flag
  double precision, intent(out) :: var
  double precision, intent(inout) :: array(N)  ! DECLARE
  double precision :: pi
  integer :: i

  if (flag == 1) then
     do i=1,n
        array(i) = dble(i)/dble(n)  
     enddo
  endif
  do i=1,1
     array(i) = array(i)**2  ! read uninitialized array element. ERROR
  end do
  i = min(n, min(n/2,1))
  var = array(i)    
  return
end subroutine sub1

