!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_f_r.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array is passed to an external
!                        function as a dummy argument; 
!                        The array is real.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        dummy argument in external function
!                        real data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none

  real, pointer, dimension(:) :: ptr
  real :: var, fct1
  double precision :: pi
  integer :: N,istat,i, flag
 
  N = 10
  allocate(ptr(N),STAT=istat)
  if( istat==0) then
     pi = 4.d0 * atan(1.0)
     flag = int(sin(2.d0*pi))
     var = fct1(ptr,N,flag)
     print *,' var ',var
  end if
  deallocate(ptr)
end program unitia

real function fct1(array,N,flag)
  implicit none
  integer, intent(in) :: N,flag 
  real, intent(inout) :: array(N)  ! DECLARE
  integer :: i
  if (flag == 1) then
     do i=1,n
        array(i) = dble(i)
     enddo
  endif
  do i=1,1
     array(i) = array(i)**2    ! read uninitialized array element. ERROR
  end do
  i = min(n, min(n/2,1))
  fct1 = array(i)  
  return
end function fct1
