!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_h_r.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array declared in a module function; 
!                        The array is real.
!
!     Support files:     F_A_2_2_h_r_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        in module function 
!                        real data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  use F_A_2_2_h_s_r
  implicit none
  double precision :: pi
  real :: ans
  integer :: i, N,istat
  real, dimension(:), pointer :: ptr
  
  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))
  N = 100
  allocate(ptr(N),STAT=istat)
  if (istat == 0) then
     do i=1,N
        ptr(i) = dble(i)/dble(N)
     end do
     ans = fct1(N,flag,ans)
     print *,'ans = ',ans,' arr(n) =',ptr(n)
  end if
  deallocate(ptr)
end program test
