!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_2_2_i_z.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized dynamically allocated pointer
!                        uninitialized array is passed to a 
!                        module subroutine as a dummy argument; 
!                        The array is complex.
!
!     Support files:     F_A_2_2_i_z_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized dynamically allocated pointer 
!                        dummy argument in a module subroutine 
!                        complex data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program test
  use F_A_2_2_i_s_z
  implicit none
  double precision :: pi
  complex :: ans
  integer :: i, N,istat
  complex, pointer,dimension(:) :: arr
  
  pi = 4.0*atan(1.d0)
  flag = int(sin(2.d0*pi))
  N = 100
  allocate(arr(N),STAT=istat)
  if (istat == 0) then
     call sub1(arr,N,flag,ans)
     print *,'ans = ',ans,' arr(n) =',arr(n)
  end if
  deallocate(arr)
end program test
