!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_a_a.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is declared in an internal subroutine; 
!                        The array is character string.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        in internal subroutine 
!                        character string type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer, parameter :: N=20
  double precision :: pi
  character(len=N) :: str
  character(len=N) :: str1
  character(len=N) :: arr1  ! DECLARE
  integer :: i, flag

  pi = 4.0*atan(1.d0)
  flag = sin(2.d0*pi)
  str = 'teststeststeststests'
  str1 = str
  call sub1(str1)
  print *,'str1 :',str1,' str :',str

  contains
    subroutine sub1(a)
      character(*), intent(inout) :: a 
      integer :: i
      if (flag == 1) then
        print *,'flag =',flag, ' initialize arr in sub1'
        arr1 = repeat('1234',4)
      endif
      a = arr1(1:1)  ! read uninitialized array element. ERROR
      print *,a
    end subroutine sub1
  end program main
      

