!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_a_d.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is declared in an internal subroutine; 
!                        The variable is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        in internal subroutine 
!                        double precision data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  double precision :: var, expr
  double precision :: pi
  double precision :: tmp   ! DECLARE
  integer :: flag
  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))

  var = 10.d0
  expr = 1.d0
  call sub1(expr)
  var = expr
  print *,'var',var,' expr',expr
  contains
    subroutine sub1(a)
      double precision, intent(inout) :: a
      if (flag == 1) then
         tmp = 100.0
      endif
      a = tmp**2 +5.0       ! read the uninitialized variable. ERROR
      return
    end subroutine sub1
end program main
