!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_a_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is declared in an internal subroutine; 
!                        The variable is derived data type.
!
!     Support files:     F_A_3_1_a_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        in internal subroutine 
!                        derived data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  type(record) :: var, expr
  type(record) :: tmp  ! DECLARE 
  double precision :: pi
  integer :: flag
  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))

  var%age = 10
  var%gender = 'f'
  expr%age = 11
  expr%gender = 'f'
  call sub1(expr)
  var = expr
  print *,'var',var,' expr',expr
  contains
    subroutine sub1(a)
      type(record), intent(inout) :: a     
      if (flag == 1) then
         tmp%age = 15
         tmp%gender = 'f'
      endif
      a%age = tmp%age*2.0       ! read the uninitialized variable. ERROR
      a%gender = 'm'
      return
    end subroutine sub1
end program main
