!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_b_z.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is declared in an internal function; 
!                        The variable is complex.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        in internal function 
!                        complex data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  complex :: var, expr
  complex :: tmp     ! DECLARE
  double precision :: pi
  integer :: flag

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))

  var = cmplx(20.0,asin(0.5))
  expr = var - cmplx(10,asin(0.5))

  expr = fct1()
  var = expr
  print *,'var',var,' expr',expr
  contains
    complex function fct1()

      if (flag == 1) then
         tmp = cmplx(atan(3.0),cos(20.0))
      endif
      fct1 = 10.0 + tmp**2       ! read the uninitialized variable. ERROR
      return
    end function fct1
end program main
