!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_c_r.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is declared in an external subroutine; 
!                        The variable is real.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        in external subroutine 
!                        real data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  real :: var, expr
  double precision :: pi
  integer :: flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))
  var = 10.d0
  expr = 1.d0
  call sub1(expr,flag)
  print *,'var',var,' expr',expr
end program main

subroutine sub1(a,flag)
  implicit none
  integer, intent(in) :: flag
  real, intent(inout) :: a
  real :: tmp   ! DECLARE

  if (flag == 1) then
      tmp = 15.0
  endif
  a =  tmp**2 + 5     ! read the uninitialized variable. ERROR
  return
end subroutine sub1

