!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_c_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is declared in an external subroutine; 
!                        The variable is derived data type.
!
!     Support files:     F_A_3_1_c_t.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        in external subroutine 
!                        derived data type 
!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  type(record) :: var, expr
  double precision :: pi
  integer :: flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))
  var%age = 10
  var%gender = 'f'
  expr%age = 11
  expr%gender = 'f'
  call sub1(expr,flag)
  print *,'var',var,' expr',expr
end program main

subroutine sub1(a,flag)
  use F_A_test_para 
  implicit none
  integer, intent(in) :: flag
  type(record), intent(inout) :: a
  type(record) :: tmp       ! DECLARE 

  if (flag == 1) then
     tmp%age = 15
     tmp%gender = 'f'
  endif
  a%age = tmp%age*2.0       ! read the uninitialized variable. ERROR
  a%gender = 'm'
  return
end subroutine sub1

