!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_d_a.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is declared in an external function; 
!                        The array is character string.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        in external function 
!                        character string type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer, parameter :: N=20
  character(len=N) :: str
  character(len=N) :: str1, fct1
  double precision :: pi
  integer :: i, flag

  pi = atan(1.0)*4.0 
  flag = int(sin(2.0*pi))
  str = ' 1234567890 '
  str1 = fct1(N, flag)
  print *,'str1 :',str1,' str:', str
end program main

character(len=20) function fct1(N, flag)
  implicit none
  integer, intent(in) :: N, flag
  character(len=N) :: arr    ! DECLARE
  double precision :: pi
  integer :: i

  if ( flag == 1) then
     print *,'flag=',flag,' initialize arr in fct1'
     arr = repeat('12345',4)
  endif
  fct1 = arr(1:1)  ! read from an uninitialized array. ERROR
  return
end function fct1
