!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_d_y.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is declared in an external function; 
!                        The variable is complex.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        in external function 
!                        complex data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  complex (kind=kind(1.d0)) :: var, expr
  complex (kind=kind(1.d0)), external :: fct1
  double precision :: pi
  integer :: flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))
  var = cmplx(20.0,asin(0.5))
  expr = var - cmplx(10,asin(0.5))

  expr = fct1(flag)
  print *,'var',var,' expr',expr
end program main

complex (kind=kind(1.d0)) function fct1(flag)
  implicit none
  integer, intent(in) :: flag
  complex (kind=kind(1.d0)) :: tmp         ! DECLARE

  if (flag == 1) then
      tmp =  cmplx(atan(1.0),cos(20.0))
  endif
  fct1 = tmp**2      ! read the uninitialized variable. ERROR
  return
end function fct1
