!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_1_1_e_a.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized statically allocated array
!                        uninitialized array is passed to an external 
!                        subroutine as a dummy argument; 
!                        The array is character string.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized static array 
!                        dummy argument in external subroutine
!                        character string type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program unitia
  implicit none
  integer, parameter :: N=20
  character(len=N) :: str
  character(len=N) :: str1
  double precision :: pi
  integer :: flag
  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))

  call sub1(str,str1,flag)
  
  print *,'str1 :',str1,' str:', str
end program unitia

subroutine sub1(array,a, flag)
  character(*), intent(inout) :: array  ! DECLARE
  character(*), intent(out) :: a
  integer, intent(in) :: flag
  integer :: i

  if ( flag == 1) then
     print *,'flag=',flag,' initialize arr in fct1'
     array = repeat('12345',4)
  endif      

  a = array(1:1)     ! read uninitialized array element. ERROR
end subroutine sub1
  
