!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_e_c.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is passed to an external 
!                        subroutine as a dummy argument; 
!                        The variable is character.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        dummy argument in external subroutine
!                        character type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  character :: var
  character :: expr, tmp
  double precision :: pi
  integer :: flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0)) 
  var = '1'
  call sub1(tmp, expr,flag)
  var = expr
  print *,'var',var,' expr',expr,' tmp',tmp
end program main

subroutine sub1(a,aout,flag)
  implicit none
  integer, intent(in)::flag
  character, intent(inout) :: a,aout     ! DECLARE
  if (flag == 1) then
      a = '1'
  endif
  aout = achar(iachar(a)+10)           ! read the uninitialized variable. ERROR
  return
end subroutine sub1

