!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_e_l.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is passed to an external 
!                        subroutine as a dummy argument; 
!                        The variable is logical.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        dummy argument in external subroutine
!                        logical data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  logical :: var
  logical :: expr, tmp
  double precision :: pi
  integer :: flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0)) 
  var = .false.
  call sub1(tmp, var, expr, flag)
  var = expr
  print *,'var',var,' expr',expr,' tmp',tmp
end program main

subroutine sub1(avar, bvar, aout,flag)
  implicit none
  integer, intent(in)::flag
  logical, intent(inout) :: avar,bvar,aout     ! DECLARE
  if (flag == 1) then
      avar = .false. .or. bvar
  endif
  aout = .not. avar         ! read the uninitialized variable. ERROR
  return
end subroutine sub1

