!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_f_d.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is passed to an external
!                        function as a dummy argument; 
!                        The variable is double precision.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        dummy argument in external function
!                        double precision data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  double precision :: var
  double precision :: expr, tmp
  double precision :: fct1
  double precision :: pi
  integer :: flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))
  var = 10.d0
  expr = 2.d0
  expr = fct1(tmp,flag)
  var = expr
  print *,'var',var,' expr',expr,' tmp',tmp
end program main

double precision function fct1(avar,flag)
  implicit none
  integer, intent(in) ::flag
  double precision, intent(inout) :: avar  ! DECLARE

  if (flag == 1) then
      avar = 15.0
  endif
  fct1 = 10 + avar**2  ! read the uninitialized variable. ERROR    
  return
end function fct1

