!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_f_l.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is passed to an external
!                        function as a dummy argument; 
!                        The variable is logical.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        dummy argument in external function
!                        logical data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  logical :: var
  logical :: expr, tmp
  logical :: fct1
  double precision :: pi
  integer :: flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))
  var = .true.
  expr = .false. 
  expr = fct1(tmp,flag,var)
  var = expr
  print *,'var',var,' expr',expr,' tmp',tmp
end program main

logical function fct1(avar,flag,bvar)
  implicit none
  integer, intent(in) ::flag
  logical, intent(inout) :: avar,bvar   ! DECLARE 

  if (flag == 1) then
      avar = .true. .and. bvar
  endif
  fct1 = .not. avar     ! read the uninitialized variable. ERROR
  return
end function fct1

