!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_f_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is passed to an external
!                        function as a dummy argument; 
!                        The variable is derived data type.
!
!     Support files:     F_A_3_1_f_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        dummy argument in external function
!                        derived data type 
!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  type(record) :: var
  type(record) :: expr, tmp
  type(record) :: fct1
  double precision :: pi
  integer :: flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))
  var%age = 10
  var%gender = 'f'
  expr%age = 11
  expr%gender = 'm'
  expr = fct1(tmp,flag)
  var = expr
  print *,'var',var,' expr',expr,' tmp',tmp
end program main

function fct1(a,flag)
  use F_A_test_para 
  implicit none
  integer, intent(in) ::flag
  type(record) :: fct1
  type(record), intent(inout) :: a    ! DECLARE 

  if (flag == 1) then
      a%age = 15
      a%gender = 'f'
  endif
  fct1%age = a%age + 10     ! read the uninitialized variable. ERROR
  fct1%gender = 'm'
  return
end function fct1

