!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_3_1_f_y.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized scalar
!                        uninitialized variable is passed to an external
!                        function as a dummy argument; 
!                        The variable is complex.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized scalar 
!                        dummy argument in external function
!                        complex data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  complex (kind=kind(1.d0)) :: var
  complex (kind=kind(1.d0)) :: expr, tmp
  complex (kind=kind(1.d0)), external :: fct1
  double precision :: pi
  integer :: flag

  pi = 4.0*atan(1.0)
  flag = int(sin(pi*2.0))

  var = cmplx(20.0, 20.0)
  expr = var - cmplx(10,asin(0.5))

  expr = fct1(tmp,flag)
  print *,'var',var,' expr',expr,' tmp',tmp
end program main

complex (kind=kind(1.d0)) function fct1(avar,flag)
  implicit none
  integer, intent(in) ::flag
  complex (kind=kind(1.d0)), intent(inout) :: avar  ! DECLARE

  if (flag == 1) then
      avar = cmplx(atan(1.0),cos(20.0))
  endif
  fct1 = avar**2 + 10      ! read the uninitialized variable. ERROR
  return
end function fct1

