!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_b_c.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is declared in an internal function; 
!                        The variable is character.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        in internal function 
!                        character type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  character :: char1
  character, pointer :: ptr  ! DECLARE
  integer :: flag
  double precision :: pi
  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))

  char1= '1'
  char1 = fct1()
  print *,'a',char1

contains

  character function fct1()
    character, target :: expr

    if (flag ==1) then
        expr = 'c'
    endif
    
    ptr=>expr
    fct1 = achar(iachar(ptr)+10)   !read the uninitialized variable through pointer. ERROR
    return
  end function fct1

end program main
