!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_b_z.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is declared in an internal function; 
!                        The variable is complex.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        in internal function 
!                        complex data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  complex :: a  
  complex, pointer :: ptr   ! DECLARE
  integer :: flag
  double precision :: pi
  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))

  a= cmplx(atan(3.0),cos(20.0))
  a = fct1()
  print *,'a',a

contains

  complex function fct1()
    complex, target :: expr 

    if (flag ==1) then
       expr = cmplx(20.0,asin(0.5))
    endif
    
    ptr=>expr
    fct1 = ptr**2   !read the uninitialized variable through pointer. ERROR
    return
  end function fct1

end program main
