!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_c_c.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is declared in an external subroutine; 
!                        The variable is character.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        in external subroutine 
!                        character type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  character :: char1
  integer :: flag
  double precision :: pi

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))
  char1='1'
  call sub1(char1,flag)
  print *,'a = ',char1
end program main

subroutine sub1(var,flag)
  implicit none
  integer, intent(in) :: flag
  character, intent(inout)  :: var 

  character, pointer :: ptr  ! DECLARE 
  character, target :: expr

  if (flag ==1) then
     expr = 'a'
  endif

  ptr=>expr
  var = achar(iachar(ptr)+10)   ! read the uninitialized variable through pointer. ERROR
  return
end subroutine sub1


