!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_d_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is declared in an external function; 
!                        The variable is derived data type.
!
!     Support files:     F_A_4_1_d_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        in external function 
!                        derived data type 
!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  type(record) :: a,fct1
  integer :: flag
  double precision :: pi

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))  
  a%age = 10
  a%gender = 'f'
  a = fct1(flag)
  print *,'a',a
end program main
function fct1(flag)
  use F_A_test_para 
  implicit none
  integer, intent(in)::flag
  type(record) :: fct1
  type(record), pointer :: ptr    ! DECLARE
  type(record), target :: expr

  if (flag ==1) then
     expr%age = 20
     expr%gender = 'm'
  endif

  ptr=>expr
  fct1%age = ptr%age+1   ! read the uninitialized variable through pointer. ERROR
  fct1%gender = 'm'
  return
end function fct1

