!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_e_c.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is passed to an external 
!                        subroutine as a dummy argument; 
!                        The variable is character.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        dummy argument in external subroutine
!                        character type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  character, pointer :: ptr
  character, target :: expr
  integer :: flag
  double precision :: pi

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))
  ptr => expr
  call sub1(ptr,flag)
  print *,'ptr ',ptr
end program main

subroutine sub1(var,flag)
  implicit none
  integer, intent(in) :: flag
  character, intent(inout) :: var  ! DECLARE 
  character :: exprloc  

  if (flag ==1) then
     var = '1'
  endif  
  exprloc =  achar(iachar(var)+10) ! read the uninitialized variable through pointer. ERROR
  var = achar(iachar(exprloc)-1) 
  return
end subroutine sub1


