!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_e_i.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is passed to an external 
!                        subroutine as a dummy argument; 
!                        The variable is integer.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        dummy argument in external subroutine
!                        integer data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer, pointer :: ptr
  integer, target :: expr
  integer :: flag
  double precision :: pi

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))
  ptr => expr
  call sub1(ptr,flag)
  print *,'ptr ',ptr
end program main

subroutine sub1(avar,flag)
  implicit none
  integer, intent(in) :: flag
  integer, intent(inout) :: avar   ! DECLARE 
  integer :: exprloc

  if (flag ==1) then
     avar = 1
  endif  
  exprloc = 10 
  avar = avar**2 + exprloc**2 ! read the uninitialized variable through pointer. ERROR
  return
end subroutine sub1


