!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_e_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is passed to an external 
!                        subroutine as a dummy argument; 
!                        The variable is derived data type.
!
!     Support files:     F_A_4_1_e_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        dummy argument in external subroutine
!                        derived data type 
!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  type(record), pointer :: ptr
  type(record), target :: expr
  integer :: flag
  double precision :: pi

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))
  ptr => expr
  call sub1(ptr,flag)
  print *,'ptr ',ptr
end program main

subroutine sub1(expr,flag)
  use F_A_test_para 
  implicit none
  integer, intent(in) :: flag
  type(record), intent(inout) :: expr   ! DECLARE 
  type(record) :: exprloc,tmp

  if (flag ==1) then
     expr%age = 20
     expr%gender = 'm'
  endif  
  exprloc%age = 10
  exprloc%gender = 'f'

  tmp%age = expr%age*2 ! read the uninitialized variable through pointer. ERROR
  tmp%gender = 'f'
  expr = tmp
  return
end subroutine sub1


