!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_f_c.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is passed to an external
!                        function as a dummy argument; 
!                        The variable is character.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        dummy argument in external function
!                        character type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer :: flag
  double precision :: pi
  character, pointer :: ptr
  character, target :: expr
  character ::  var,fct1

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))  
  ptr => expr
  var = fct1(ptr,flag)
  print *,'var ',var
end program main

character function fct1(char1,flag)
  implicit none
  integer,intent(in) :: flag 
  character, intent(inout) :: char1 ! DECLARE
  character :: exprloc

  if (flag ==1) then
     char1= 'a'
  endif 
  exprloc = achar(iachar(char1)+10)  ! read the uninitialized variable through pointer. ERROR
  fct1 = achar(iachar(exprloc)+1)  
  return
end function fct1


