!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_f_t.f90
!
!     Summary:           uninitialized variable 
!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is passed to an external
!                        function as a dummy argument; 
!                        The variable is derived data type.
!
!     Support files:     F_A_4_1_f_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        dummy argument in external function
!                        derived data type 
!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  integer :: flag
  double precision :: pi
  type(record), pointer :: ptr
  type(record), target :: expr
  type(record) ::  var,fct1

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))  
  ptr => expr
  var = fct1(ptr,flag)
  print *,'var ',var
end program main
function fct1(expr,flag)
  use F_A_test_para 
  implicit none
  integer,intent(in) :: flag 
  type(record) :: fct1
  type(record), intent(inout) :: expr  ! DECLARE
  type(record) :: exprloc

  if (flag ==1) then
     expr%age = 20
     expr%gender = 'm'
  endif
  exprloc%age = 10
  exprloc%gender = 'f'
  fct1%age = expr%age*2 ! read the uninitialized variable through pointer. ERROR
  fct1%gender = 'f'

  return
end function fct1


