!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_1_f_z.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read an uninitialized variable through 
!                        a pointer associated with the uninitialzed target;
!                        uninitialized variable is passed to an external
!                        function as a dummy argument; 
!                        The variable is complex.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          pointer associated with uninitialized variable 
!                        dummy argument in external function
!                        complex data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer :: flag
  double precision :: pi
  complex, pointer :: ptr
  complex, target :: expr
  complex ::  var,fct1

  pi = atan(1.0)*4.0
  flag = int(sin(2.0*pi))  
  ptr => expr
  var = fct1(ptr,flag)
  print *,'var ',var
end program main

complex function fct1(avar,flag)
  implicit none
  integer,intent(in) :: flag 
  complex, intent(inout) :: avar  ! DECLARE
  complex :: exprloc

  if (flag ==1) then
     avar = cmplx(atan(3.0),cos(20.0))
  endif
  exprloc =  cmplx(20.0,atan(1.0))
  fct1 = avar**2+exprloc   ! read the uninitialized variable through pointer. ERROR
  return
end function fct1


