!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_2_a_d.f90
!
!     Summary:           uninitialized pointer 
!
!     Test description:  read unassociated pointer
!                        uninitialized pointer is declared in an internal subroutine; 
!                        The pointer is double precision.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          unassociated pointer
!                        in internal subroutine 
!                        double precision data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  double precision :: var
  double precision, pointer :: ptr  ! DECLARE
  double precision :: pi
  integer :: flag
  
  pi = 4.0*atan(1.0)
  flag = int(sin(pi))
  
  call sub1(var)
  print *,'var ',var
  contains
    subroutine sub1(var)
      double precision :: var
      double precision, target :: exprloc

      if (flag == 1) then
         exprloc = 10.d0
         ptr => exprloc
      end if
      var = ptr**2  ! read the uninitialized variable through pointer. ERROR
      return
    end subroutine sub1
  end program main
