!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_2_b_i.f90
!
!     Summary:           uninitialized pointer 
!
!     Test description:  read unassociated pointer
!                        uninitialized pointer is declared in an internal function; 
!                        The pointer is integer.
!
!     Support files:     not needed
!
!     Env. requirements: not needed
!
!     Keywords:          unassociated pointer
!                        in internal function 
!                        integer data type 
!
!     Last modified:     07/12/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer :: var
  integer, pointer :: ptr    ! DECLARE
  double precision :: pi
  integer :: flag
  
  pi = 4.0*atan(1.0)
  flag = int(sin(pi))
  
  var = fct1()
  print *,'var ',var
  contains
     integer function fct1()
      integer, target :: exprloc

      if (flag == 1) then
         exprloc = 10
         ptr => exprloc
      end if
      fct1 = ptr  ! read the uninitialized variable through pointer. ERROR
      return 
    end function fct1
  end program main
