!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_2_c_z.f90
!
!     Summary:           uninitialized pointer 

!
!     Test description:  read unassociated pointer
!                        uninitialized pointer is declared in an external subroutine; 
!                        The pointer is complex.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          unassociated pointer
!                        in external subroutine 
!                        complex data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  complex :: var
  double precision :: pi
  integer :: flag
  
  pi = 4.0*atan(1.0)
  flag = int(sin(pi))

  call sub1(var,flag)
  print *,'var ',var
  stop
end program main

subroutine sub1(var,flag)
  implicit none
  integer, intent(in) :: flag
  complex, intent(inout) :: var
  complex, pointer :: ptr   ! DECLARE
  complex ,target :: expr
  if (flag == 1) then
     expr = cmplx(20.0,asin(0.5))
     ptr=>expr
  end if
  var = ptr      ! read the uninitialized variable through pointer. ERROR
  return
end subroutine sub1

