!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_2_d_t.f90
!
!     Summary:           uninitialized pointer 
!
!     Test description:  read unassociated pointer
!                        uninitialized pointer is declared in an external function; 
!                        The pointer is derived data type.
!
!     Support files:     F_A_4_2_d_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          unassociated pointer
!                        in external function 
!                        derived data type 
!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  type(record) :: var, fct1
  double precision :: pi
  integer :: flag
  
  pi = 4.0*atan(1.0)
  flag = int(sin(pi))

  var = fct1(flag)
  print *,'var ',var
  stop
end program main
function fct1(flag)
  use F_A_test_para 
  implicit none
  integer, intent(in) :: flag

  type(record) :: fct1
  type(record), pointer :: ptr  ! DECLARE
  type(record) ,target :: expr
  if (flag == 1) then
     expr%age = 20
     expr%gender = 'm'
     ptr=>expr
  end if
  fct1 = ptr      ! read the uninitialized variable through pointer. ERROR
  return
end function fct1
