!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_2_e_c.f90
!
!     Summary:           uninitialized pointer 

!
!     Test description:  read unassociated pointer
!                        uninitialized pointer is passed to an external 
!                        subroutine as a dummy argument; 
!                        The pointer is character.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          unassociated pointer
!                        dummy argument in external subroutine
!                        character type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  character, pointer :: ptr
  character, target :: var
  double precision :: pi
  integer :: flag
  
  pi = 4.0*atan(1.0)
  flag = int(sin(pi))
  if (flag == 1) then
     var = '1'
     ptr => var
  end if
  var = 'b'
  call sub1(ptr, var, flag)  
  print *,'ptr ',ptr

end program main
  
subroutine sub1(avar,results,flag)
  implicit none
  integer, intent(in) :: flag
  character, intent(inout) :: results
  character, intent(inout) :: avar  ! DECLARE 

  character :: exprloc 
  exprloc = achar(iachar('a')+21)
  if ( flag ==1) then
     avar = achar(iachar(exprloc)-10)
  end if
  results = achar(iachar(avar)+10)   ! read the uninitialized variable through pointer. ERROR
  return
end subroutine sub1

