!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_2_e_t.f90
!
!     Summary:           uninitialized pointer 
!
!     Test description:  read unassociated pointer
!                        uninitialized pointer is passed to an external 
!                        subroutine as a dummy argument; 
!                        The pointer is derived data type.
!
!     Support files:     F_A_4_2_e_t_s.f90
!
!     Env. requirements: not needed
!
!     Keywords:          unassociated pointer
!                        dummy argument in external subroutine
!                        derived data type 
!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_test_para 
  implicit none
  type(record), pointer :: ptr
  type(record), target :: var
  double precision :: pi
  integer :: flag
  
  pi = 4.0*atan(1.0)
  flag = int(sin(pi))
  var%age = 25
  var%gender = 'f'
  if (flag == 1) then
     ptr => var
  end if
  call sub1(ptr, var, flag)  
  print *,'ptr ',ptr

end program main
  
subroutine sub1(var,results,flag)
  use F_A_test_para 
  implicit none
  integer, intent(in) :: flag
  type(record), intent(inout) :: results
  type(record), intent(inout) :: var     ! DECLARE 
  type(record) :: exprloc
  
  exprloc%age = 20
  exprloc%gender = 'm'
  if ( flag ==1) then
     var = exprloc
  end if

  results%age = exprloc%age + var%age   ! read the uninitialized variable through pointer. ERROR
  results%gender = exprloc%gender
  return
end subroutine sub1

