!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_4_2_f_z.f90
!
!     Summary:           uninitialized pointer 

!
!     Test description:  read unassociated pointer
!                        uninitialized pointer is passed to an external
!                        function as a dummy argument; 
!                        The pointer is complex.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          unassociated pointer
!                        dummy argument in external function
!                        complex data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  complex, pointer :: ptr
  complex, target :: var
  complex :: fct1
  double precision :: pi
  integer :: flag
  
  pi = 4.0*atan(1.0)
  flag = int(sin(pi))
  if (flag == 1) then
     var = 99.0
     ptr => var
  end if
  var = log(3.0)
  var = fct1(ptr, flag)  
  print *,'ptr ',ptr

end program main
  
complex function fct1(avar, flag)
  implicit none
  integer, intent(in) :: flag
  complex, intent(inout) :: avar   ! DECLARE

  complex :: exprloc 
  exprloc = cmplx(20.0,atan(1.0))
  if ( flag ==1) then
     avar = exprloc **2
  end if

  fct1 = exprloc + avar   ! read the uninitialized variable through pointer. ERROR
  return
end function fct1
