!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .        
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_5_1_c_i.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized integer in ALLOCATE statement
!                        uninitialized variable is declared in an external subroutine; 
!                        The variable is integer.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized integer
!                        in ALLOCATE statement 
!                        in external subroutine 
!                        integer data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  implicit none
  integer :: i,j,flag
  integer :: m,n
  double precision :: var
  double precision :: tmp
  double precision, allocatable :: arr(:,:)
  m=2
  call random_number(tmp)
  flag = int(sin(tmp))
  print *,'flag ',flag
  if (flag == 1) then
     n=10
  end if
  allocate(arr(m,m))    
  do i=1,m
     do j=1,m
        arr(i,j) = dble(i*j)
     end do
  end do
  call sub1(var,n)
  print *,var
  deallocate(arr)
  contains
    subroutine sub1(vars,nbound)
      double precision, intent(out) :: vars
      integer,intent(in) :: nbound     ! DECLARE
      double precision, allocatable :: array(:,:)

      allocate(array(nbound,m))        ! ERROR
      if (flag==1) then
         array(1,1) = arr(1,1)*10.d0
      end if
      vars = array(m/2,m/2)
      deallocate(array)
    end subroutine sub1
end program main
