!***************************************************************************  
!  copyright (c) 2005 Iowa State University, Glenn Luecke, James Coyle,
!  James Hoekstra, Marina Kraeva, Olga Taborskaia, Andre Wehe, Ying Xu,
!  and Ziyu Zhang, All rights reserved.
!  Licensed under the Educational Community License version 1.0.
!  See the full agreement at http://rted.public.iastate.edu/ .         
!***************************************************************************
!***************************************************************************
!
!     Name of the test:  F_A_5_1_f_i.f90
!
!     Summary:           uninitialized variable 

!
!     Test description:  read uninitialized integer in ALLOCATE statement
!                        uninitialized variable is passed to an external
!                        function as a dummy argument; 
!                        The variable is integer.

!
!     Support files:     not needed

!
!     Env. requirements: not needed
!
!     Keywords:          uninitialized integer
!                        in ALLOCATE statement 
!                        dummy argument in external function
!                        integer data type 

!
!     Last modified:     05/16/05
!
!     Programmer:        Ying Xu
!*************************************************************************
program main
  use F_A_5_1_f_i_s
  implicit none
  integer :: i,j,flag
  integer :: m,n
  double precision :: var
  double precision :: tmp
  double precision, allocatable :: arr(:,:)
  m=2
  call random_number(tmp)
  flag = int(sin(tmp))
  if (flag ==0 ) then
     n=m
  end if
  allocate(arr(n,m))    
  do i=1,n
     do j=1,m
        arr(i,j) = dble(i*j)
     end do
  end do
  call sub1(var,flag,arr,m)
  print *,var
  deallocate(arr)
end program main

